;
;
; *****************************************************************
; *                PureBasic COM Object Framework                 *
; *****************************************************************
; *                                                               *
; *              02/25/2006  by Timo 'fr34k' Harter               * 
; *                    purebasic@freak1.de                        *
; *                                                               *
; *  Please consult the 'Readme.txt' that came with this archive  *
; *  on the use of these macros/commands. This framework may      *
; *  be used under the terms of the MIT license displayed below.  *
; *                                                               *
; *****************************************************************
;
;
; Copyright (c) 2006 Timo Harter
;
; Permission is hereby granted, free of charge, to any person obtaining a copy 
; of this software and associated documentation files (the "Software"), to deal 
; in the Software without restriction, including without limitation the rights 
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies 
; of the Software, and to permit persons to whom the Software is furnished to do 
; so, subject to the following conditions:
; 
; The above copyright notice and this permission notice shall be included in 
; all copies or substantial portions of the Software.
; 
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
; INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
; PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
; HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION 
; OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
; SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
;
;
;

Structure __COM_IUnknown_Vtbl
  QueryInterface.l
  AddRef.l
  Release.l
EndStructure 

DefineIID(IID_IUnknown, $00000000, $0000, $0000, $C0, $00, $00, $00, $00, $00, $00, $46)

XIncludeFile #PB_Compiler_Home+"COMFramework\KnownInterfaces.pb"

Macro __COM_VTABLE_SetMethod(ObjectName, InterfaceName, MethodName, NbArguments)
  CompilerIf Defined(ObjectName#_#InterfaceName#_#MethodName, #PB_Procedure)
    __COM_#ObjectName#_#InterfaceName#_Vtbl\MethodName = @ObjectName#_#InterfaceName#_#MethodName()
  CompilerElse
    CompilerIf Defined(__COM_METHOD_#ObjectName#_#InterfaceName#_#MethodName#_REUSE_DEFINED__, #PB_Constant)
      __COM_#ObjectName#_#InterfaceName#_Vtbl\MethodName = PeekL(?__COM_#ObjectName#_#InterfaceName#_#MethodName#_REALMETHOD)
    CompilerElse
      CompilerIf Defined(__COM_METHOD_#ObjectName#_#InterfaceName#_#MethodName#__EMPTY_DEFINED__, #PB_Constant)        
        Goto __COM_#ObjectName#_#InterfaceName#_#MethodName#_EMPTYEND
        __COM_#ObjectName#_#InterfaceName#_#MethodName#_EMPTYSTART:
        !MOV EAX, dword [__COM_#ObjectName#_#InterfaceName#_#MethodName#_RETURNVALUE]
        !RET 4*(NbArguments+1)
        __COM_#ObjectName#_#InterfaceName#_#MethodName#_EMPTYEND:
        __COM_#ObjectName#_#InterfaceName#_Vtbl\MethodName = ?__COM_#ObjectName#_#InterfaceName#_#MethodName#_EMPTYSTART      
      CompilerElse
        __COM_#ObjectName#_#InterfaceName#_Vtbl\MethodName = @__COM_DefaultMethod#NbArguments()
      CompilerEndIf
    CompilerEndIf
  CompilerEndIf
  CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)
    __COM_VTABLE_DEBUG_SetMethodDebug(ObjectName, InterfaceName, MethodName, NbArguments)
  CompilerEndIf
EndMacro

Macro __COM_VTABLE_SetIUnknown(ObjectName, InterfaceName)
  __COM_#ObjectName#_#InterfaceName#_Vtbl\QueryInterface = @__COM_#ObjectName#_IUnknown_QueryInterface()
  __COM_#ObjectName#_#InterfaceName#_Vtbl\AddRef         = @__COM_#ObjectName#_IUnknown_AddRef()
  __COM_#ObjectName#_#InterfaceName#_Vtbl\Release        = @__COM_#ObjectName#_IUnknown_Release() 
EndMacro

Macro __COM_VTABLE_SetDebug(ObjectName, InterfaceName)
  CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)
    Define __COM_index
    For __COM_index = 0 To 99
      __COM_#ObjectName#_#InterfaceName#_Vtbl\__COM_CrashTraceMethod = @__COM_CrashTraceMethod()
    Next __COM_index  
  CompilerEndIf
EndMacro

; fix for a small bug in direct asm and macros
Macro __COM_COLON
:
EndMacro

Macro __COM_QUOTE
"
EndMacro

Macro __COM_STRING(X)
__COM_QUOTE#X#__COM_QUOTE
EndMacro

Macro __COM_FinalObjectStructure(ObjectName)  
  CompilerIf Defined(__COM_#ObjectName#_9, #PB_Structure)
    Structure ObjectName Extends __COM_#ObjectName#_9
  CompilerElse
    CompilerIf Defined(__COM_#ObjectName#_8, #PB_Structure)
      Structure ObjectName Extends __COM_#ObjectName#_8
    CompilerElse
      CompilerIf Defined(__COM_#ObjectName#_7, #PB_Structure)
        Structure ObjectName Extends __COM_#ObjectName#_7
      CompilerElse
        CompilerIf Defined(__COM_#ObjectName#_6, #PB_Structure)
          Structure ObjectName Extends __COM_#ObjectName#_6
        CompilerElse
          CompilerIf Defined(__COM_#ObjectName#_5, #PB_Structure)
            Structure ObjectName Extends __COM_#ObjectName#_5
          CompilerElse
            CompilerIf Defined(__COM_#ObjectName#_4, #PB_Structure)
              Structure ObjectName Extends __COM_#ObjectName#_4
            CompilerElse
              CompilerIf Defined(__COM_#ObjectName#_3, #PB_Structure)
                Structure ObjectName Extends __COM_#ObjectName#_3
              CompilerElse
                CompilerIf Defined(__COM_#ObjectName#_2, #PB_Structure)
                  Structure ObjectName Extends __COM_#ObjectName#_2
                CompilerElse
                  CompilerIf Defined(__COM_#ObjectName#_1, #PB_Structure)
                    Structure ObjectName Extends __COM_#ObjectName#_1
                  CompilerElse
                    CompilerIf Defined(__COM_#ObjectName#_0, #PB_Structure)
                      CompilerError "The Class needs to implement at least one Interface!"
                    CompilerElse
                      CompilerError "The Specified Class does not exist."
                    CompilerEndIf
                  CompilerEndIf
                CompilerEndIf
              CompilerEndIf
            CompilerEndIf
          CompilerEndIf
        CompilerEndIf
      CompilerEndIf
    CompilerEndIf
  CompilerEndIf
  
  CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)   
    CompilerIf Defined(__COM_DEADTRACKING_ENABLED, #PB_Constant) 
      __COM_IsDeadObject.l
    CompilerEndIf
  CompilerEndIf
EndMacro

Macro __COM_Class(ObjectName)
  CompilerIf Defined(ObjectName, #PB_Structure)|Defined(ObjectName, #PB_Interface)
    CompilerError "Class Name allready used as Structure/Interface"
  CompilerEndIf 
  
  Declare __COM_#ObjectName#_IUnknown_QueryInterface(*_THIS, *IID.IID, *pObject.LONG)
  Declare __COM_#ObjectName#_IUnknown_AddRef(*_THIS)
  Declare __COM_#ObjectName#_IUnknown_Release(*_THIS)  
  Declare __COM_#ObjectName#_CONSTRUCTOR_REAL()    
  
  DataSection
    __COM_#ObjectName#_IUnknown_Vtbl:
      Data.l @__COM_#ObjectName#_IUnknown_QueryInterface()
      Data.l @__COM_#ObjectName#_IUnknown_AddRef()
      Data.l @__COM_#ObjectName#_IUnknown_Release() 
      
      CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)   
        __COM_DEBUG_IUnknownExtend
      CompilerEndIf
  EndDataSection
  
  Structure __COM_#ObjectName#_0
    IUnknown.l
  EndStructure

  #__COM_INTERFACETEST_#ObjectName#___UNDEFINED___DEFINED = 1 ; for checks in COMInterface()
EndMacro


Macro COMInterface(ObjectName, InterfaceName, Extends1=__UNDEFINED__, Extends2=__UNDEFINED__, Extends3=__UNDEFINED__, Extends4=__UNDEFINED__, Extends5=__UNDEFINED__)
  CompilerIf Defined(__COM_KNOWN_INTERFACE_#InterfaceName, #PB_Constant) = 0
    CompilerError "Unknown Interface: "+__COM_STRING(InterfaceName)
  CompilerEndIf
  XIncludeFile #PB_Compiler_Home+"COMFrameWork\Interfaces\" + __COM_STRING(InterfaceName) + ".pb"  
  #__COM_INTERFACE_#ObjectName#_#InterfaceName#_DEFINED__ = 1
  
  CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)   
    __COM_VTABLE_DebugExtend(InterfaceName)
    Global __COM_#ObjectName#_#InterfaceName#_Vtbl.__COM_#InterfaceName#_Vtbl_DEBUG
  CompilerElse
    Global __COM_#ObjectName#_#InterfaceName#_Vtbl.__COM_#InterfaceName#_Vtbl
  CompilerEndIf
  
  ; define constants for extended interfaces
  CompilerIf Defined(__COM_INTERFACETEST_#ObjectName#_#Extends1#_DEFINED, #PB_Constant) = 0
    CompilerIf Defined(__COM_KNOWN_INTERFACE_#Extends1, #PB_Constant) = 0
      CompilerError "Unknown Interface: "+__COM_STRING(Extends1)
    CompilerEndIf  
    XIncludeFile #PB_Compiler_Home+"COMFrameWork\Interfaces\" + __COM_STRING(Extends1) + ".pb"  
    #__COM_INTERFACE_#ObjectName#_#Extends1#_DEFINED__ = 1
    #__COM_INTERFACE_#ObjectName#_#Extends1#_EXTENDS__ = 1
  CompilerEndIf
  
  CompilerIf Defined(__COM_INTERFACETEST_#ObjectName#_#Extends2#_DEFINED, #PB_Constant) = 0
    CompilerIf Defined(__COM_KNOWN_INTERFACE_#Extends2, #PB_Constant) = 0
      CompilerError "Unknown Interface: "+__COM_STRING(Extends2)
    CompilerEndIf  
    XIncludeFile #PB_Compiler_Home+"COMFrameWork\Interfaces\" + __COM_STRING(Extends2) + ".pb"  
    #__COM_INTERFACE_#ObjectName#_#Extends2#_DEFINED__ = 1
    #__COM_INTERFACE_#ObjectName#_#Extends2#_EXTENDS__ = 1
  CompilerEndIf
  
  CompilerIf Defined(__COM_INTERFACETEST_#ObjectName#_#Extends3#_DEFINED, #PB_Constant) = 0
    CompilerIf Defined(__COM_KNOWN_INTERFACE_#Extends3, #PB_Constant) = 0
      CompilerError "Unknown Interface: "+__COM_STRING(Extends3)
    CompilerEndIf  
    XIncludeFile #PB_Compiler_Home+"COMFrameWork\Interfaces\" + __COM_STRING(Extends3) + ".pb"  
    #__COM_INTERFACE_#ObjectName#_#Extends3#_DEFINED__ = 1
    #__COM_INTERFACE_#ObjectName#_#Extends3#_EXTENDS__ = 1
  CompilerEndIf
  
  CompilerIf Defined(__COM_INTERFACETEST_#ObjectName#_#Extends4#_DEFINED, #PB_Constant) = 0
    CompilerIf Defined(__COM_KNOWN_INTERFACE_#Extends4, #PB_Constant) = 0
      CompilerError "Unknown Interface: "+__COM_STRING(Extends4)
    CompilerEndIf  
    XIncludeFile #PB_Compiler_Home+"COMFrameWork\Interfaces\" + __COM_STRING(Extends4) + ".pb"  
    #__COM_INTERFACE_#ObjectName#_#Extends4#_DEFINED__ = 1
    #__COM_INTERFACE_#ObjectName#_#Extends4#_EXTENDS__ = 1
  CompilerEndIf
  
  CompilerIf Defined(__COM_INTERFACETEST_#ObjectName#_#Extends5#_DEFINED, #PB_Constant) = 0
    CompilerIf Defined(__COM_KNOWN_INTERFACE_#Extends5, #PB_Constant) = 0
      CompilerError "Unknown Interface: "+__COM_STRING(Extends5)
    CompilerEndIf  
    XIncludeFile #PB_Compiler_Home+"COMFrameWork\Interfaces\" + __COM_STRING(Extends5) + ".pb"  
    #__COM_INTERFACE_#ObjectName#_#Extends5#_DEFINED__ = 1
    #__COM_INTERFACE_#ObjectName#_#Extends5#_EXTENDS__ = 1
  CompilerEndIf
  
  CompilerIf Defined(ObjectName, #PB_Structure)
    CompilerError "COMInterface() must be before COMClassData()/COMConstructor()/COMDestructor() !"
  CompilerElse
    CompilerIf Defined(__COM_#ObjectName#_9, #PB_Structure)
      CompilerError "One Class can only implement up to 9 Interfaces."     
    CompilerElse
      CompilerIf Defined(__COM_#ObjectName#_8, #PB_Structure)
        Structure __COM_#ObjectName#_9 Extends __COM_#ObjectName#_8
      CompilerElse
        CompilerIf Defined(__COM_#ObjectName#_7, #PB_Structure)
          Structure __COM_#ObjectName#_8 Extends __COM_#ObjectName#_7
        CompilerElse
          CompilerIf Defined(__COM_#ObjectName#_6, #PB_Structure)
            Structure __COM_#ObjectName#_7 Extends __COM_#ObjectName#_6
          CompilerElse
            CompilerIf Defined(__COM_#ObjectName#_5, #PB_Structure)
              Structure __COM_#ObjectName#_6 Extends __COM_#ObjectName#_5
            CompilerElse
              CompilerIf Defined(__COM_#ObjectName#_4, #PB_Structure)
                Structure __COM_#ObjectName#_5 Extends __COM_#ObjectName#_4
              CompilerElse
                CompilerIf Defined(__COM_#ObjectName#_3, #PB_Structure)
                  Structure __COM_#ObjectName#_4 Extends __COM_#ObjectName#_3
                CompilerElse
                  CompilerIf Defined(__COM_#ObjectName#_2, #PB_Structure)
                    Structure __COM_#ObjectName#_3 Extends __COM_#ObjectName#_2
                  CompilerElse
                    CompilerIf Defined(__COM_#ObjectName#_1, #PB_Structure)
                      Structure __COM_#ObjectName#_2 Extends __COM_#ObjectName#_1
                    CompilerElse
                      CompilerIf Defined(__COM_#ObjectName#_0, #PB_Structure)
                        Structure __COM_#ObjectName#_1 Extends __COM_#ObjectName#_0
                      CompilerElse
                        CompilerError "The specified Class does not exist."
                      CompilerEndIf
                    CompilerEndIf
                  CompilerEndIf
                CompilerEndIf
              CompilerEndIf
            CompilerEndIf
          CompilerEndIf
        CompilerEndIf
      CompilerEndIf
    CompilerEndIf
  CompilerEndIf

    CompilerIf Defined(__COM_INTERFACETEST_#ObjectName#_#Extends1#_DEFINED, #PB_Constant) = 0
      StructureUnion
    CompilerEndIf

      ; Main interface comes first for the debugging consistency
      InterfaceName.l
  
    ; extended interfaces are put in a structureunion, so they use the main vtable
    CompilerIf Defined(__COM_INTERFACETEST_#ObjectName#_#Extends1#_DEFINED, #PB_Constant) = 0      
      Extends1.l
      
      CompilerIf Defined(__COM_INTERFACETEST_#ObjectName#_#Extends2#_DEFINED, #PB_Constant) = 0
        Extends2.l
      CompilerEndIf
      CompilerIf Defined(__COM_INTERFACETEST_#ObjectName#_#Extends3#_DEFINED, #PB_Constant) = 0
        Extends3.l
      CompilerEndIf
      CompilerIf Defined(__COM_INTERFACETEST_#ObjectName#_#Extends4#_DEFINED, #PB_Constant) = 0
        Extends4.l
      CompilerEndIf
      CompilerIf Defined(__COM_INTERFACETEST_#ObjectName#_#Extends5#_DEFINED, #PB_Constant) = 0
        Extends5.l
      CompilerEndIf
      
      EndStructureUnion
    CompilerEndIf
    
  EndStructure
EndMacro

Macro COMClassData(ObjectName)
  CompilerIf Defined(New_#ObjectName, #PB_Procedure)|Defined(__COM_#ObjectName#_DESTRUCTOR, #PB_Procedure)
    CompilerError "COMClassData() must be before Constructor()/Destructor() !"
  CompilerEndIf
  
  __COM_FinalObjectStructure(ObjectName)
  __COM_ObjectRefCount.l     
EndMacro

Macro EndCOMClassData
  EndStructure
EndMacro

Macro COMConstructor(ObjectName, Arguments=())
  CompilerIf Defined(ObjectName, #PB_Structure) = 0
    __COM_FinalObjectStructure(ObjectName)
      __COM_ObjectRefCount.l
    EndStructure
  CompilerEndIf  
  
  Procedure New_#ObjectName#Arguments
    Protected *THIS.ObjectName = __COM_#ObjectName#_CONSTRUCTOR_REAL()   
    
  CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)
    __COM_DEBUG("CALLING: "+__COM_STRING(ObjectName)+"::Constructor", #COM_DEBUG_MethodEntry)    
    Protected __COM_DEBUG_ObjectName$ = __COM_STRING(ObjectName)
  CompilerEndIf
EndMacro

Macro COMConstructorReturn
  CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)
    If *THIS
      __COM_DEBUG("RETURNED: "+__COM_DEBUG_ObjectName$+"::Constructor (successfull)", #COM_DEBUG_MethodLeave)
      __COM_DEBUG("STATS:"+__COM_DEBUG_ObjectName$+": New Object created. (ObjectRefCount=1)",  #COM_DEBUG_ObjectStats)            
    Else
      __COM_DEBUG("RETURNED: "+__COM_DEBUG_ObjectName$+"::Constructor (failed)", #COM_DEBUG_MethodLeave)
      __COM_DEBUG("STATS:"+__COM_DEBUG_ObjectName$+": Object creation failed!",  #COM_DEBUG_ObjectStats)    
    EndIf
  CompilerEndIf  

  ProcedureReturn @*THIS\
EndMacro

Macro EndCOMConstructor
  COMConstructorReturn IUnknown ; important if the user does not call it
  EndProcedure
EndMacro

Macro COMDestructor(ObjectName)
  CompilerIf Defined(ObjectName, #PB_Structure) = 0
    __COM_FinalObjectStructure(ObjectName)
      __COM_ObjectRefCount.l
    EndStructure
  CompilerEndIf  

  Procedure __COM_#ObjectName#_DESTRUCTOR(*THIS.ObjectName) ;}
EndMacro

Macro EndCOMDestructor  
  EndProcedure 
EndMacro

Macro COMMethodOf(ObjectName)
  : CompilerIf Defined(ObjectName, #PB_Structure) = 0
    CompilerError "The specified Class does not exist."
  CompilerEndIf    
  While *THIS\IUnknown <> ?__COM_#ObjectName#_IUnknown_Vtbl: *THIS - 4: Wend  
EndMacro


Macro COMReuseMethod(ObjectName, ImplementedInterface, MethodName, InterfaceName)
  CompilerIf Defined(ObjectName, #PB_Structure) = 0
    CompilerError "The specified Class does not exist."
  CompilerEndIf   
  CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#ImplementedInterface#_DEFINED__, #PB_Constant) = 0
    CompilerError "The specified Class does not implement the given Interface."
  CompilerEndIf
  CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#InterfaceName#_DEFINED__, #PB_Constant) = 0
    CompilerError "The specified Class does not implement the given Interface."
  CompilerEndIf
  CompilerIf Defined(ObjectName#_#ImplementedInterface#_#MethodName, #PB_Procedure) = 0
    CompilerError "The specified Method to be reused is not implemented."
  CompilerEndIf  
  
  #__COM_METHOD_#ObjectName#_#InterfaceName#_#MethodName#__REUSE_DEFINED__ = 1
  DataSection
    __COM_#ObjectName#_#InterfaceName#_#MethodName#_REALMETHOD#_COM_COLON
    Data.l @ObjectName#_#ImplementedInterface#_#MethodName()
  EndDataSection
EndMacro

Macro COMEmptyMethod(ObjectName, InterfaceName, MethodName, ReturnValue)
  CompilerIf Defined(ObjectName, #PB_Structure) = 0
    CompilerError "The specified Class does not exist."
  CompilerEndIf   
  CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#InterfaceName#_DEFINED__, #PB_Constant) = 0
    CompilerError "The specified Class does not implement the given Interface."
  CompilerEndIf
  
  #__COM_METHOD_#ObjectName#_#InterfaceName#_#MethodName#__EMPTY_DEFINED__ = 1
  DataSection
    !__COM_#ObjectName#_#InterfaceName#_#MethodName#_RETURNVALUE#__COM_COLON
    Data.l ReturnValue
  EndDataSection
EndMacro

Macro EndCOMClass(ObjectName, I1, I2=__UNDEFINED__, I3=__UNDEFINED__, I4=__UNDEFINED__, I5=__UNDEFINED__, I6=__UNDEFINED__, I7=__UNDEFINED__, I8=__UNDEFINED__, I9=__UNDEFINED__)  
  CompilerIf Defined(ObjectName, #PB_Structure) = 0
    __COM_FinalObjectStructure(ObjectName)
      __COM_ObjectRefCount.l
    EndStructure
  CompilerEndIf 
  
  CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I1#_DEFINED__, #PB_Constant) = 0
    CompilerError "The spefied Interface '"+__COM_QUOTE#I1#__COM_QUOTE+"' is not implemented by this Class."
  CompilerEndIf
  
  #__COM_INTERFACE_#ObjectName#___UNDEFINED___UNDEFINED = 1 ; a trick for the following cecks  
  CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I2#_DEFINED__, #PB_Constant) = 0
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I2#_UNDEFINED, #PB_Constant) = 0
      CompilerError "The spefied Interface '"+__COM_QUOTE#I2#__COM_QUOTE+"' is not implemented by this Class."
    CompilerEndIf
  CompilerEndIf  
  CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I3#_DEFINED__, #PB_Constant) = 0
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I3#_UNDEFINED, #PB_Constant) = 0
      CompilerError "The spefied Interface '"+__COM_QUOTE#I3#__COM_QUOTE+"' is not implemented by this Class."
    CompilerEndIf
  CompilerEndIf  
  CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I4#_DEFINED__, #PB_Constant) = 0
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I4#_UNDEFINED, #PB_Constant) = 0
      CompilerError "The spefied Interface '"+__COM_QUOTE#I4#__COM_QUOTE+"' is not implemented by this Class."
    CompilerEndIf
  CompilerEndIf  
  CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I5#_DEFINED__, #PB_Constant) = 0
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I5#_UNDEFINED, #PB_Constant) = 0
      CompilerError "The spefied Interface '"+__COM_QUOTE#I5#__COM_QUOTE+"' is not implemented by this Class."
    CompilerEndIf
  CompilerEndIf  
  CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I6#_DEFINED__, #PB_Constant) = 0
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I6#_UNDEFINED, #PB_Constant) = 0
      CompilerError "The spefied Interface '"+__COM_QUOTE#I6#__COM_QUOTE+"' is not implemented by this Class."
    CompilerEndIf
  CompilerEndIf  
  CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I7#_DEFINED__, #PB_Constant) = 0
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I7#_UNDEFINED, #PB_Constant) = 0
      CompilerError "The spefied Interface '"+__COM_QUOTE#I7#__COM_QUOTE+"' is not implemented by this Class."
    CompilerEndIf
  CompilerEndIf  
  CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I8#_DEFINED__, #PB_Constant) = 0
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I8#_UNDEFINED, #PB_Constant) = 0
      CompilerError "The spefied Interface '"+__COM_QUOTE#I8#__COM_QUOTE+"' is not implemented by this Class."
    CompilerEndIf
  CompilerEndIf  
  CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I9#_DEFINED__, #PB_Constant) = 0
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I9#_UNDEFINED, #PB_Constant) = 0
      CompilerError "The spefied Interface '"+__COM_QUOTE#I9#__COM_QUOTE+"' is not implemented by this Class."
    CompilerEndIf
  CompilerEndIf    
  
  CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)
    __COM_DEBUG_ImplementPrintResult(ObjectName)
  CompilerEndIf

  Procedure __COM_#ObjectName#_IUnknown_QueryInterface(*_THIS, *IID.IID, *pObject.LONG)  
    Protected *THIS.ObjectName = *_THIS        
    While *THIS\IUnknown <> ?__COM_#ObjectName#_IUnknown_Vtbl: *THIS - 4: Wend  
    
    CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)
      CompilerIf Defined(__COM_DEADTRACKING_ENABLED, #PB_Constant) 
        If *THIS\__COM_IsDeadObject ; called on a dead object
          __COM_DEBUG_IUnknownInterface("CRITICAL: ", "::QueryInterface() --> Called on a dead (allready freed) object!", #COM_DEBUG_Critical, ObjectName,I1,I2,I3,I4,I5,I6,I7,I8,I9)
          ProcedureReturn #E_INVALIDARG
        EndIf
      CompilerEndIf       
    
      __COM_DEBUG_IUnknownInterface("CALLING: ", "::QueryInterface()", #COM_DEBUG_ObjectStats, ObjectName,I1,I2,I3,I4,I5,I6,I7,I8,I9)
    CompilerEndIf
  
    If *pObject = 0
      CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)
        __COM_DEBUG_IUnknownInterface("DEBUG: ", "::QueryInterface() --> Invalid Argument as *pObject!", #COM_DEBUG_UnknownInterface, ObjectName,I1,I2,I3,I4,I5,I6,I7,I8,I9)                
      CompilerEndIf    
      ProcedureReturn #E_INVALIDARG  
      
    ElseIf CompareIID(*IID, ?IID_IUnknown): *pObject\l = @*THIS\IUnknown     
    ElseIf CompareIID(*IID, ?IID_#I1): *pObject\l = @*THIS\I1
      
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I2#_DEFINED__, #PB_Constant)
      ElseIf CompareIID(*IID, ?IID_#I2): *pObject\l = @*THIS\I2   
    CompilerEndIf
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I3#_DEFINED__, #PB_Constant)
      ElseIf CompareIID(*IID, ?IID_#I3): *pObject\l = @*THIS\I3   
    CompilerEndIf
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I4#_DEFINED__, #PB_Constant)
      ElseIf CompareIID(*IID, ?IID_#I4): *pObject\l = @*THIS\I4   
    CompilerEndIf
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I5#_DEFINED__, #PB_Constant)
      ElseIf CompareIID(*IID, ?IID_#I5): *pObject\l = @*THIS\I5   
    CompilerEndIf
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I6#_DEFINED__, #PB_Constant)
      ElseIf CompareIID(*IID, ?IID_#I6): *pObject\l = @*THIS\I6    
    CompilerEndIf
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I7#_DEFINED__, #PB_Constant)
      ElseIf CompareIID(*IID, ?IID_#I7): *pObject\l = @*THIS\I7    
    CompilerEndIf
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I8#_DEFINED__, #PB_Constant)
      ElseIf CompareIID(*IID, ?IID_#I8): *pObject\l = @*THIS\I8   
    CompilerEndIf
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I9#_DEFINED__, #PB_Constant)
      ElseIf CompareIID(*IID, ?IID_#I9): *pObject\l = @*THIS\I9    
    CompilerEndIf
    
    Else    
      CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)
        __COM_DEBUG_IUnknownInterface("DEBUG: ", "::QueryInterface() --> Unimplemented Interface requested: "+NameFromIID(*IID), #COM_DEBUG_UnknownInterface, ObjectName,I1,I2,I3,I4,I5,I6,I7,I8,I9)
      CompilerEndIf
    
      *pObject\l = 0
      ProcedureReturn #E_NOINTERFACE
    EndIf
    
    *THIS\__COM_ObjectRefCount + 1
    
    CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)
      __COM_DEBUG_IUnknownInterface("DEBUG: ", "::QueryInterface() --> Queried for: "+NameFromIID(*IID), #COM_DEBUG_ObjectStats, ObjectName,I1,I2,I3,I4,I5,I6,I7,I8,I9)
      __COM_DEBUG("STATS: "+__COM_STRING(ObjectName)+"\ObjectRefCount = "+Str(*THIS\__COM_ObjectRefCount), #COM_DEBUG_ObjectStats)
    CompilerEndIf     
    
    ProcedureReturn #S_OK
  
  EndProcedure
  
  Procedure __COM_#ObjectName#_IUnknown_AddRef(*_THIS)
    Protected *THIS.ObjectName = *_THIS
    While *THIS\IUnknown <> ?__COM_#ObjectName#_IUnknown_Vtbl: *THIS - 4: Wend  
    *THIS\__COM_ObjectRefCount + 1  
  
    CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)
      CompilerIf Defined(__COM_DEADTRACKING_ENABLED, #PB_Constant) 
        If *THIS\__COM_IsDeadObject ; called on a dead object
          __COM_DEBUG_IUnknownInterface("CRITICAL: ", "::Addref() --> Called on a dead (allready freed) object!", #COM_DEBUG_Critical, ObjectName,I1,I2,I3,I4,I5,I6,I7,I8,I9)
          ProcedureReturn 0
        EndIf
      CompilerEndIf    
    
      __COM_DEBUG_IUnknownInterface("CALLING: ", "::AddRef()", #COM_DEBUG_ObjectStats, ObjectName,I1,I2,I3,I4,I5,I6,I7,I8,I9)
      __COM_DEBUG("STATS: "+__COM_STRING(ObjectName)+"\ObjectRefCount = "+Str(*THIS\__COM_ObjectRefCount), #COM_DEBUG_ObjectStats)
    CompilerEndIf 
       
    ProcedureReturn *THIS\__COM_ObjectRefCount
  EndProcedure
  
  Procedure __COM_#ObjectName#_IUnknown_Release(*_THIS)
    Protected *THIS.ObjectName = *_THIS
    While *THIS\IUnknown <> ?__COM_#ObjectName#_IUnknown_Vtbl: *THIS - 4: Wend  
    *THIS\__COM_ObjectRefCount - 1
    
    CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)      
      CompilerIf Defined(__COM_DEADTRACKING_ENABLED, #PB_Constant) 
        If *THIS\__COM_IsDeadObject ; called on a dead object
          __COM_DEBUG_IUnknownInterface("CRITICAL: ", "::Release() --> Called on a dead (allready freed) object!", #COM_DEBUG_Critical, ObjectName,I1,I2,I3,I4,I5,I6,I7,I8,I9)          
          ProcedureReturn 0
        EndIf
      CompilerEndIf      
    
      __COM_DEBUG_IUnknownInterface("CALLING: ", "::Release()", #COM_DEBUG_ObjectStats, ObjectName,I1,I2,I3,I4,I5,I6,I7,I8,I9)
      If *THIS\__COM_ObjectRefCount = 0
        __COM_DEBUG("STATS: "+__COM_STRING(ObjectName)+"\ObjectRefCount = 0 (destroying object)", #COM_DEBUG_ObjectStats)
        __COM_DEBUG_UnregisterObject(*THIS, ObjectName)        
        
      CompilerIf Defined(__COM_DEADTRACKING_ENABLED, #PB_Constant) 
        *THIS\__COM_IsDeadObject = 1
      CompilerEndIf
        
      Else
        __COM_DEBUG("STATS: "+__COM_STRING(ObjectName)+"\ObjectRefCount = "+Str(*THIS\__COM_ObjectRefCount), #COM_DEBUG_ObjectStats)
      EndIf
    CompilerEndIf      
    
    If *THIS\__COM_ObjectRefCount = 0
      CompilerIf Defined(__COM_#ObjectName#_DESTRUCTOR, #PB_Procedure)  
        CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)
          __COM_DEBUG("CALLING: "+__COM_STRING(ObjectName)+"::Destructor", #COM_DEBUG_MethodEntry)
        CompilerEndIf      
        __COM_#ObjectName#_DESTRUCTOR(*THIS)
        CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)
          __COM_DEBUG("RETURNED: "+__COM_STRING(ObjectName)+"::Destructor", #COM_DEBUG_MethodLeave)
        CompilerEndIf          
      CompilerEndIf  
              
      ; only free the memory if dead object tracking is disabled
      CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)
        CompilerIf Defined(__COM_DEBUG_DisableDeadTracking, #PB_Constant) <> 0
          FreeMemory(*THIS)
        CompilerEndIf
      CompilerElse
        FreeMemory(*THIS)      
      CompilerEndIf        
            
      ProcedureReturn 0
    Else    
      ProcedureReturn *THIS\__COM_ObjectRefCount  
    EndIf
  EndProcedure

  Procedure __COM_#ObjectName#_CONSTRUCTOR_REAL()     
    Protected *THIS.ObjectName = AllocateMemory(SizeOf(ObjectName))
    
    *THIS\IUnknown = ?__COM_#ObjectName#_IUnknown_Vtbl
    
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I1#_EXTENDS__, #PB_Constant) = 0
      *THIS\I1 = @__COM_#ObjectName#_#I1#_Vtbl
    CompilerEndIf
        
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I2#_DEFINED__, #PB_Constant)
      CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I2#_EXTENDS__, #PB_Constant) = 0
        *THIS\I2 = @__COM_#ObjectName#_#I2#_Vtbl
      CompilerEndIf
    CompilerEndIf
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I3#_DEFINED__, #PB_Constant)
      CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I3#_EXTENDS__, #PB_Constant) = 0
        *THIS\I3 = @__COM_#ObjectName#_#I3#_Vtbl
      CompilerEndIf
    CompilerEndIf
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I4#_DEFINED__, #PB_Constant)
      CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I4#_EXTENDS__, #PB_Constant) = 0
        *THIS\I4 = @__COM_#ObjectName#_#I4#_Vtbl
      CompilerEndIf
    CompilerEndIf
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I5#_DEFINED__, #PB_Constant)
      CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I5#_EXTENDS__, #PB_Constant) = 0
        *THIS\I5 = @__COM_#ObjectName#_#I5#_Vtbl
      CompilerEndIf
    CompilerEndIf
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I6#_DEFINED__, #PB_Constant)
      CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I6#_EXTENDS__, #PB_Constant) = 0
        *THIS\I6 = @__COM_#ObjectName#_#I6#_Vtbl
      CompilerEndIf
    CompilerEndIf
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I7#_DEFINED__, #PB_Constant)
      CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I7#_EXTENDS__, #PB_Constant) = 0
        *THIS\I7 = @__COM_#ObjectName#_#I7#_Vtbl
      CompilerEndIf
    CompilerEndIf
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I8#_DEFINED__, #PB_Constant)
      CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I8#_EXTENDS__, #PB_Constant) = 0
        *THIS\I8 = @__COM_#ObjectName#_#I8#_Vtbl
      CompilerEndIf
    CompilerEndIf
    CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I9#_DEFINED__, #PB_Constant)
      CompilerIf Defined(__COM_INTERFACE_#ObjectName#_#I9#_EXTENDS__, #PB_Constant) = 0
        *THIS\I9 = @__COM_#ObjectName#_#I9#_Vtbl
      CompilerEndIf
    CompilerEndIf
       
    *THIS\__COM_ObjectRefCount = 1  
    
    CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)
      __COM_DEBUG_RegisterObject(*THIS, ObjectName, I1,I2,I3,I4,I5,I6,I7,I8,I9)
    CompilerEndIf
    
    ProcedureReturn *THIS ; IUnknown pointer of the object
  EndProcedure
  
  CompilerIf Defined(New_#ObjectName, #PB_Procedure) = 0
    Procedure New_#ObjectName()        
      CompilerIf Defined(__COM_DEBUGGING_ENABLED, #PB_Constant)
        Protected *THIS = __COM_#ObjectName#_CONSTRUCTOR_REAL() 
        If *THIS
          __COM_DEBUG("STATS: "+__COM_STRING(ObjectName)+": New Object created. (__COM_ObjectRefCount=1)",  #COM_DEBUG_ObjectStats)            
        Else
          __COM_DEBUG("STATS: "+__COM_STRING(ObjectName)+": Object creation failed!",  #COM_DEBUG_ObjectStats)    
        EndIf        
        ProcedureReturn *THIS
      CompilerElse
        ProcedureReturn __COM_#ObjectName#_CONSTRUCTOR_REAL() 
      CompilerEndIf
    EndProcedure
  CompilerEndIf
     
EndMacro


Procedure __COM_DefaultMethod0 (a): ProcedureReturn #E_NOTIMPL: EndProcedure
Procedure __COM_DefaultMethod1 (a,b): ProcedureReturn #E_NOTIMPL: EndProcedure
Procedure __COM_DefaultMethod2 (a,b,c): ProcedureReturn #E_NOTIMPL: EndProcedure
Procedure __COM_DefaultMethod3 (a,b,c,d): ProcedureReturn #E_NOTIMPL: EndProcedure
Procedure __COM_DefaultMethod4 (a,b,c,d,e): ProcedureReturn #E_NOTIMPL: EndProcedure
Procedure __COM_DefaultMethod5 (a,b,c,d,e,f): ProcedureReturn #E_NOTIMPL: EndProcedure
Procedure __COM_DefaultMethod6 (a,b,c,d,e,f,g): ProcedureReturn #E_NOTIMPL: EndProcedure
Procedure __COM_DefaultMethod7 (a,b,c,d,e,f,g,h): ProcedureReturn #E_NOTIMPL: EndProcedure
Procedure __COM_DefaultMethod8 (a,b,c,d,e,f,g,h,i): ProcedureReturn #E_NOTIMPL: EndProcedure
Procedure __COM_DefaultMethod9 (a,b,c,d,e,f,g,h,i,j): ProcedureReturn #E_NOTIMPL: EndProcedure
Procedure __COM_DefaultMethod10(a,b,c,d,e,f,g,h,i,j,k): ProcedureReturn #E_NOTIMPL: EndProcedure
Procedure __COM_DefaultMethod11(a,b,c,d,e,f,g,h,i,j,k,l): ProcedureReturn #E_NOTIMPL: EndProcedure
Procedure __COM_DefaultMethod12(a,b,c,d,e,f,g,h,i,j,k,l,m): ProcedureReturn #E_NOTIMPL: EndProcedure
Procedure __COM_DefaultMethod13(a,b,c,d,e,f,g,h,i,j,k,l,m,n): ProcedureReturn #E_NOTIMPL: EndProcedure
Procedure __COM_DefaultMethod14(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o): ProcedureReturn #E_NOTIMPL: EndProcedure
Procedure __COM_DefaultMethod15(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p): ProcedureReturn #E_NOTIMPL: EndProcedure

