;
; PureBasic COM Object Framework
;   by Timo 'fr34k' Harter (purebasic@freak1.de)
;
; See the 'Readme.txt' for help and licence information.
;

DataSection
  __COM_ErrorCodes:
  Data.l $8000FFFF: Data$ "E_UNEXPECTED",  "Catastrophic failure"
  Data.l $80004001: Data$ "E_NOTIMPL",  "Not implemented"
  Data.l $8007000E: Data$ "E_OUTOFMEMORY",  "Ran out of memory"
  Data.l $80070057: Data$ "E_INVALIDARG",  "One or more arguments are invalid"
  Data.l $80004002: Data$ "E_NOINTERFACE",  "No such interface supported"
  Data.l $80004003: Data$ "E_POINTER",  "Invalid pointer"
  Data.l $80070006: Data$ "E_HANDLE",  "Invalid handle"
  Data.l $80004004: Data$ "E_ABORT",  "Operation aborted"
  Data.l $80004005: Data$ "E_FAIL",  "Unspecified error"
  Data.l $80070005: Data$ "E_ACCESSDENIED",  "General access denied error"
  Data.l $80000001: Data$ "E_NOTIMPL",  "Not implemented"
  Data.l $80000002: Data$ "E_OUTOFMEMORY",  "Ran out of memory"
  Data.l $80000003: Data$ "E_INVALIDARG",  "One or more arguments are invalid"
  Data.l $80000004: Data$ "E_NOINTERFACE",  "No such interface supported"
  Data.l $80000005: Data$ "E_POINTER",  "Invalid pointer"
  Data.l $80000006: Data$ "E_HANDLE",  "Invalid handle"
  Data.l $80000007: Data$ "E_ABORT",  "Operation aborted"
  Data.l $80000008: Data$ "E_FAIL",  "Unspecified error"
  Data.l $80000009: Data$ "E_ACCESSDENIED",  "General access denied error"
  Data.l $8000000A: Data$ "E_PENDING",  "The data necessary to complete this operation is not yet available."
  Data.l $80004006: Data$ "CO_E_INIT_TLS",  "Thread local storage failure"
  Data.l $80004007: Data$ "CO_E_INIT_SHARED_ALLOCATOR",  "Get shared memory allocator failure"
  Data.l $80004008: Data$ "CO_E_INIT_MEMORY_ALLOCATOR",  "Get memory allocator failure"
  Data.l $80004009: Data$ "CO_E_INIT_CLASS_CACHE",  "Unable to initialize class cache"
  Data.l $8000400A: Data$ "CO_E_INIT_RPC_CHANNEL",  "Unable to initialize RPC services"
  Data.l $8000400B: Data$ "CO_E_INIT_TLS_SET_CHANNEL_CONTROL",  "Cannot set thread local storage channel control"
  Data.l $8000400C: Data$ "CO_E_INIT_TLS_CHANNEL_CONTROL",  "Could not allocate thread local storage channel control"
  Data.l $8000400D: Data$ "CO_E_INIT_UNACCEPTED_USER_ALLOCATOR",  "The user supplied memory allocator is unacceptable"
  Data.l $8000400E: Data$ "CO_E_INIT_SCM_MUTEX_EXISTS",  "The OLE service mutex already exists"
  Data.l $8000400F: Data$ "CO_E_INIT_SCM_FILE_MAPPING_EXISTS",  "The OLE service file mapping already exists"
  Data.l $80004010: Data$ "CO_E_INIT_SCM_MAP_VIEW_OF_FILE",  "Unable to map view of file for OLE service"
  Data.l $80004011: Data$ "CO_E_INIT_SCM_EXEC_FAILURE",  "Failure attempting to launch OLE service"
  Data.l $80004012: Data$ "CO_E_INIT_ONLY_SINGLE_THREADED",  "There was an attempt to call CoInitialize a second time while single threaded"
  Data.l $80004013: Data$ "CO_E_CANT_REMOTE",  "A Remote activation was necessary but was not allowed"
  Data.l $80004014: Data$ "CO_E_BAD_SERVER_NAME",  "A Remote activation was necessary but the server name provided was invalid"
  Data.l $80004015: Data$ "CO_E_WRONG_SERVER_IDENTITY",  "The class is configured to run as a security id different from the caller"
  Data.l $80004016: Data$ "CO_E_OLE1DDE_DISABLED",  "Use of Ole1 services requiring DDE windows is disabled"
  Data.l $80004017: Data$ "CO_E_RUNAS_SYNTAX",  "A RunAs specification must be <domain name>\<user name> or simply <user name>"
  Data.l $80004018: Data$ "CO_E_CREATEPROCESS_FAILURE",  "The server process could not be started.  The pathname may be incorrect."
  Data.l $80004019: Data$ "CO_E_RUNAS_CREATEPROCESS_FAILURE",  "The server process could not be started as the configured identity.  The pathname may be incorrect or unavailable."
  Data.l $8000401A: Data$ "CO_E_RUNAS_LOGON_FAILURE",  "The server process could not be started because the configured identity is incorrect.  Check the username and password."
  Data.l $8000401B: Data$ "CO_E_LAUNCH_PERMSSION_DENIED",  "The client is not allowed to launch this server."
  Data.l $8000401C: Data$ "CO_E_START_SERVICE_FAILURE",  "The service providing this server could not be started."
  Data.l $8000401D: Data$ "CO_E_REMOTE_COMMUNICATION_FAILURE",  "This computer was unable to communicate with the computer providing the server."
  Data.l $8000401E: Data$ "CO_E_SERVER_START_TIMEOUT",  "The server did not respond after being launched."
  Data.l $8000401F: Data$ "CO_E_CLSREG_INCONSISTENT",  "The registration information for this server is inconsistent or incomplete."
  Data.l $80004020: Data$ "CO_E_IIDREG_INCONSISTENT",  "The registration information for this interface is inconsistent or incomplete."
  Data.l $80004021: Data$ "CO_E_NOT_SUPPORTED",  "The operation attempted is not supported."
  Data.l $80004022: Data$ "CO_E_RELOAD_DLL",  "A dll must be loaded."
  Data.l $80004023: Data$ "CO_E_MSI_ERROR",  "A Microsoft Software Installer error was encountered."
  Data.l $80004024: Data$ "CO_E_ATTEMPT_TO_CREATE_OUTSIDE_CLIENT_CONTEXT",  "The specified activation could not occur in the client context as specified."
  Data.l $80004025: Data$ "CO_E_SERVER_PAUSED",  "Activations on the server are paused."
  Data.l $80004026: Data$ "CO_E_SERVER_NOT_PAUSED",  "Activations on the server are not paused."
  Data.l $80004027: Data$ "CO_E_CLASS_DISABLED",  "The component or application containing the component has been disabled."
  Data.l $80004028: Data$ "CO_E_CLRNOTAVAILABLE",  "The common language runtime is not available"
  Data.l $80004029: Data$ "CO_E_ASYNC_WORK_REJECTED",  "The thread-pool rejected the submitted asynchronous work."
  Data.l $8000402A: Data$ "CO_E_SERVER_INIT_TIMEOUT",  "The server started, but did not finish initializing in a timely fashion."
  Data.l $8000402B: Data$ "CO_E_NO_SECCTX_IN_ACTIVATE",  "Unable to complete the call since there is no COM+ security context inside IObjectControl.Activate."
  Data.l $80004030: Data$ "CO_E_TRACKER_CONFIG",  "The provided tracker configuration is invalid"
  Data.l $80004031: Data$ "CO_E_THREADPOOL_CONFIG",  "The provided thread pool configuration is invalid"
  Data.l $80004032: Data$ "CO_E_SXS_CONFIG",  "The provided side-by-side configuration is invalid"
  Data.l $80004033: Data$ "CO_E_MALFORMED_SPN",  "The server principal name (SPN) obtained during security negotiation is malformed."
  Data.l $80040000: Data$ "OLE_E_OLEVERB",  "Invalid OLEVERB structure"
  Data.l $80040001: Data$ "OLE_E_ADVF",  "Invalid advise flags"
  Data.l $80040002: Data$ "OLE_E_ENUM_NOMORE",  "Can't enumerate any more, because the associated data is missing"
  Data.l $80040003: Data$ "OLE_E_ADVISENOTSUPPORTED",  "This implementation doesn't take advises"
  Data.l $80040004: Data$ "OLE_E_NOCONNECTION",  "There is no connection for this connection ID"
  Data.l $80040005: Data$ "OLE_E_NOTRUNNING",  "Need to run the object to perform this operation"
  Data.l $80040006: Data$ "OLE_E_NOCACHE",  "There is no cache to operate on"
  Data.l $80040007: Data$ "OLE_E_BLANK",  "Uninitialized object"
  Data.l $80040008: Data$ "OLE_E_CLASSDIFF",  "Linked object's source class has changed"
  Data.l $80040009: Data$ "OLE_E_CANT_GETMONIKER",  "Not able to get the moniker of the object"
  Data.l $8004000A: Data$ "OLE_E_CANT_BINDTOSOURCE",  "Not able to bind to the source"
  Data.l $8004000B: Data$ "OLE_E_STATIC",  "Object is static; operation not allowed"
  Data.l $8004000C: Data$ "OLE_E_PROMPTSAVECANCELLED",  "User canceled out of save dialog"
  Data.l $8004000D: Data$ "OLE_E_INVALIDRECT",  "Invalid rectangle"
  Data.l $8004000E: Data$ "OLE_E_WRONGCOMPOBJ",  "compobj.dll is too old for the ole2.dll initialized"
  Data.l $8004000F: Data$ "OLE_E_INVALIDHWND",  "Invalid window handle"
  Data.l $80040010: Data$ "OLE_E_NOT_INPLACEACTIVE",  "Object is not in any of the inplace active states"
  Data.l $80040011: Data$ "OLE_E_CANTCONVERT",  "Not able to convert object"
  Data.l $80040012: Data$ "OLE_E_NOSTORAGE",  "Not able to perform the operation because object is not given storage yet"
  Data.l $80040064: Data$ "DV_E_FORMATETC",  "Invalid FORMATETC structure"
  Data.l $80040065: Data$ "DV_E_DVTARGETDEVICE",  "Invalid DVTARGETDEVICE structure"
  Data.l $80040066: Data$ "DV_E_STGMEDIUM",  "Invalid STDGMEDIUM structure"
  Data.l $80040067: Data$ "DV_E_STATDATA",  "Invalid STATDATA structure"
  Data.l $80040068: Data$ "DV_E_LINDEX",  "Invalid lindex"
  Data.l $80040069: Data$ "DV_E_TYMED",  "Invalid tymed"
  Data.l $8004006A: Data$ "DV_E_CLIPFORMAT",  "Invalid clipboard format"
  Data.l $8004006B: Data$ "DV_E_DVASPECT",  "Invalid aspect(s)"
  Data.l $8004006C: Data$ "DV_E_DVTARGETDEVICE_SIZE",  "tdSize parameter of the DVTARGETDEVICE structure is invalid"
  Data.l $8004006D: Data$ "DV_E_NOIVIEWOBJECT",  "Object doesn't support IViewObject interface"
  Data.l $80040100: Data$ "DRAGDROP_E_NOTREGISTERED",  "Trying to revoke a drop target that has not been registered"
  Data.l $80040101: Data$ "DRAGDROP_E_ALREADYREGISTERED",  "This window has already been registered as a drop target"
  Data.l $80040102: Data$ "DRAGDROP_E_INVALIDHWND",  "Invalid window handle"
  Data.l $80040110: Data$ "CLASS_E_NOAGGREGATION",  "Class does not support aggregation (or class object is remote)"
  Data.l $80040111: Data$ "CLASS_E_CLASSNOTAVAILABLE",  "ClassFactory cannot supply requested class"
  Data.l $80040112: Data$ "CLASS_E_NOTLICENSED",  "Class is not licensed for use"
  Data.l $80040140: Data$ "VIEW_E_DRAW",  "Error drawing view"
  Data.l $80040150: Data$ "REGDB_E_READREGDB",  "Could not read key from registry"
  Data.l $80040151: Data$ "REGDB_E_WRITEREGDB",  "Could not write key to registry"
  Data.l $80040152: Data$ "REGDB_E_KEYMISSING",  "Could not find the key in the registry"
  Data.l $80040153: Data$ "REGDB_E_INVALIDVALUE",  "Invalid value for registry"
  Data.l $80040154: Data$ "REGDB_E_CLASSNOTREG",  "Class not registered"
  Data.l $80040155: Data$ "REGDB_E_IIDNOTREG",  "Interface not registered"
  Data.l $80040156: Data$ "REGDB_E_BADTHREADINGMODEL",  "Threading model entry is not valid"
  Data.l $80040160: Data$ "CAT_E_CATIDNOEXIST",  "CATID does not exist"
  Data.l $80040161: Data$ "CAT_E_NODESCRIPTION",  "Description not found"
  Data.l $80040164: Data$ "CS_E_PACKAGE_NOTFOUND",  "No package in the software installation data in the Active Directory meets this criteria."
  Data.l $80040165: Data$ "CS_E_NOT_DELETABLE",  "Deleting this will break the referential integrity of the software installation data in the Active Directory."
  Data.l $80040166: Data$ "CS_E_CLASS_NOTFOUND",  "The CLSID was not found in the software installation data in the Active Directory."
  Data.l $80040167: Data$ "CS_E_INVALID_VERSION",  "The software installation data in the Active Directory is corrupt."
  Data.l $80040168: Data$ "CS_E_NO_CLASSSTORE",  "There is no software installation data in the Active Directory."
  Data.l $80040169: Data$ "CS_E_OBJECT_NOTFOUND",  "There is no software installation data object in the Active Directory."
  Data.l $8004016A: Data$ "CS_E_OBJECT_ALREADY_EXISTS",  "The software installation data object in the Active Directory already exists."
  Data.l $8004016B: Data$ "CS_E_INVALID_PATH",  "The path to the software installation data in the Active Directory is not correct."
  Data.l $8004016C: Data$ "CS_E_NETWORK_ERROR",  "A network error interrupted the operation."
  Data.l $8004016D: Data$ "CS_E_ADMIN_LIMIT_EXCEEDED",  "The size of this object exceeds the maximum size set by the Administrator."
  Data.l $8004016E: Data$ "CS_E_SCHEMA_MISMATCH",  "The schema for the software installation data in the Active Directory does not match the required schema."
  Data.l $8004016F: Data$ "CS_E_INTERNAL_ERROR",  "An error occurred in the software installation data in the Active Directory."
  Data.l $80040170: Data$ "CACHE_E_NOCACHE_UPDATED",  "Cache not updated"
  Data.l $80040180: Data$ "OLEOBJ_E_NOVERBS",  "No verbs for OLE object"
  Data.l $80040181: Data$ "OLEOBJ_E_INVALIDVERB",  "Invalid verb for OLE object"
  Data.l $800401A0: Data$ "INPLACE_E_NOTUNDOABLE",  "Undo is not available"
  Data.l $800401A1: Data$ "INPLACE_E_NOTOOLSPACE",  "Space for tools is not available"
  Data.l $800401C0: Data$ "CONVERT10_E_OLESTREAM_GET",  "OLESTREAM Get method failed"
  Data.l $800401C1: Data$ "CONVERT10_E_OLESTREAM_PUT",  "OLESTREAM Put method failed"
  Data.l $800401C2: Data$ "CONVERT10_E_OLESTREAM_FMT",  "Contents of the OLESTREAM not in correct format"
  Data.l $800401C3: Data$ "CONVERT10_E_OLESTREAM_BITMAP_TO_DIB",  "There was an error in a Windows GDI call while converting the bitmap to a DIB"
  Data.l $800401C4: Data$ "CONVERT10_E_STG_FMT",  "Contents of the IStorage not in correct format"
  Data.l $800401C5: Data$ "CONVERT10_E_STG_NO_STD_STREAM",  "Contents of IStorage is missing one of the standard streams"
  Data.l $800401D0: Data$ "CLIPBRD_E_CANT_OPEN",  "OpenClipboard Failed"
  Data.l $800401D1: Data$ "CLIPBRD_E_CANT_EMPTY",  "EmptyClipboard Failed"
  Data.l $800401D2: Data$ "CLIPBRD_E_CANT_SET",  "SetClipboard Failed"
  Data.l $800401D3: Data$ "CLIPBRD_E_BAD_DATA",  "Data on clipboard is invalid"
  Data.l $800401D4: Data$ "CLIPBRD_E_CANT_CLOSE",  "CloseClipboard Failed"
  Data.l $800401E0: Data$ "MK_E_CONNECTMANUALLY",  "Moniker needs to be connected manually"
  Data.l $800401E1: Data$ "MK_E_EXCEEDEDDEADLINE",  "Operation exceeded deadline"
  Data.l $800401E2: Data$ "MK_E_NEEDGENERIC",  "Moniker needs to be generic"
  Data.l $800401E3: Data$ "MK_E_UNAVAILABLE",  "Operation unavailable"
  Data.l $800401E4: Data$ "MK_E_SYNTAX",  "Invalid syntax"
  Data.l $800401E5: Data$ "MK_E_NOOBJECT",  "No object for moniker"
  Data.l $800401E6: Data$ "MK_E_INVALIDEXTENSION",  "Bad extension for file"
  Data.l $800401E7: Data$ "MK_E_INTERMEDIATEINTERFACENOTSUPPORTED",  "Intermediate operation failed"
  Data.l $800401E8: Data$ "MK_E_NOTBINDABLE",  "Moniker is not bindable"
  Data.l $800401E9: Data$ "MK_E_NOTBOUND",  "Moniker is not bound"
  Data.l $800401EA: Data$ "MK_E_CANTOPENFILE",  "Moniker cannot open file"
  Data.l $800401EB: Data$ "MK_E_MUSTBOTHERUSER",  "User input required for operation to succeed"
  Data.l $800401EC: Data$ "MK_E_NOINVERSE",  "Moniker class has no inverse"
  Data.l $800401ED: Data$ "MK_E_NOSTORAGE",  "Moniker does not refer to storage"
  Data.l $800401EE: Data$ "MK_E_NOPREFIX",  "No common prefix"
  Data.l $800401EF: Data$ "MK_E_ENUMERATION_FAILED",  "Moniker could not be enumerated"
  Data.l $800401F0: Data$ "CO_E_NOTINITIALIZED",  "CoInitialize has not been called."
  Data.l $800401F1: Data$ "CO_E_ALREADYINITIALIZED",  "CoInitialize has already been called."
  Data.l $800401F2: Data$ "CO_E_CANTDETERMINECLASS",  "Class of object cannot be determined"
  Data.l $800401F3: Data$ "CO_E_CLASSSTRING",  "Invalid class string"
  Data.l $800401F4: Data$ "CO_E_IIDSTRING",  "Invalid interface string"
  Data.l $800401F5: Data$ "CO_E_APPNOTFOUND",  "Application not found"
  Data.l $800401F6: Data$ "CO_E_APPSINGLEUSE",  "Application cannot be run more than once"
  Data.l $800401F7: Data$ "CO_E_ERRORINAPP",  "Some error in application program"
  Data.l $800401F8: Data$ "CO_E_DLLNOTFOUND",  "DLL for class not found"
  Data.l $800401F9: Data$ "CO_E_ERRORINDLL",  "Error in the DLL"
  Data.l $800401FA: Data$ "CO_E_WRONGOSFORAPP",  "Wrong OS or OS version for application"
  Data.l $800401FB: Data$ "CO_E_OBJNOTREG",  "Object is not registered"
  Data.l $800401FC: Data$ "CO_E_OBJISREG",  "Object is already registered"
  Data.l $800401FD: Data$ "CO_E_OBJNOTCONNECTED",  "Object is not connected to server"
  Data.l $800401FE: Data$ "CO_E_APPDIDNTREG",  "Application was launched but it didn't register a class factory"
  Data.l $800401FF: Data$ "CO_E_RELEASED",  "Object has been released"
  Data.l $00040200: Data$ "EVENT_S_SOME_SUBSCRIBERS_FAILED",  "An event was able to invoke some but not all of the subscribers"
  Data.l $80040201: Data$ "EVENT_E_ALL_SUBSCRIBERS_FAILED",  "An event was unable to invoke any of the subscribers"
  Data.l $00040202: Data$ "EVENT_S_NOSUBSCRIBERS",  "An event was delivered but there were no subscribers"
  Data.l $80040203: Data$ "EVENT_E_QUERYSYNTAX",  "A syntax error occurred trying to evaluate a query string"
  Data.l $80040204: Data$ "EVENT_E_QUERYFIELD",  "An invalid field name was used in a query string"
  Data.l $80040205: Data$ "EVENT_E_INTERNALEXCEPTION",  "An unexpected exception was raised"
  Data.l $80040206: Data$ "EVENT_E_INTERNALERROR",  "An unexpected internal error was detected"
  Data.l $80040207: Data$ "EVENT_E_INVALID_PER_USER_SID",  "The owner SID on a per-user subscription doesn't exist"
  Data.l $80040208: Data$ "EVENT_E_USER_EXCEPTION",  "A user-supplied component or subscriber raised an exception"
  Data.l $80040209: Data$ "EVENT_E_TOO_MANY_METHODS",  "An interface has too many methods to fire events from"
  Data.l $8004020A: Data$ "EVENT_E_MISSING_EVENTCLASS",  "A subscription cannot be stored unless its event class already exists"
  Data.l $8004020B: Data$ "EVENT_E_NOT_ALL_REMOVED",  "Not all the objects requested could be removed"
  Data.l $8004020C: Data$ "EVENT_E_COMPLUS_NOT_INSTALLED",  "COM+ is required for this operation, but is not installed"
  Data.l $8004020D: Data$ "EVENT_E_CANT_MODIFY_OR_DELETE_UNCONFIGURED_OBJECT",  "Cannot modify or delete an object that was not added using the COM+ Admin SDK"
  Data.l $8004020E: Data$ "EVENT_E_CANT_MODIFY_OR_DELETE_CONFIGURED_OBJECT",  "Cannot modify or delete an object that was added using the COM+ Admin SDK"
  Data.l $8004020F: Data$ "EVENT_E_INVALID_EVENT_CLASS_PARTITION",  "The event class for this subscription is in an invalid partition"
  Data.l $80040210: Data$ "EVENT_E_PER_USER_SID_NOT_LOGGED_ON",  "The owner of the PerUser subscription is not logged on to the system specified"
  Data.l $8004D000: Data$ "XACT_E_ALREADYOTHERSINGLEPHASE",  "Another single phase resource manager has already been enlisted in this transaction."
  Data.l $8004D001: Data$ "XACT_E_CANTRETAIN",  "A retaining commit or abort is not supported"
  Data.l $8004D002: Data$ "XACT_E_COMMITFAILED",  "The transaction failed to commit for an unknown reason. The transaction was aborted."
  Data.l $8004D003: Data$ "XACT_E_COMMITPREVENTED",  "Cannot call commit on this transaction object because the calling application did not initiate the transaction."
  Data.l $8004D004: Data$ "XACT_E_HEURISTICABORT",  "Instead of committing, the resource heuristically aborted."
  Data.l $8004D005: Data$ "XACT_E_HEURISTICCOMMIT",  "Instead of aborting, the resource heuristically committed."
  Data.l $8004D006: Data$ "XACT_E_HEURISTICDAMAGE",  "Some of the states of the resource were committed while others were aborted, likely because of heuristic decisions."
  Data.l $8004D007: Data$ "XACT_E_HEURISTICDANGER",  "Some of the states of the resource may have been committed while others may have been aborted, likely because of heuristic decisions."
  Data.l $8004D008: Data$ "XACT_E_ISOLATIONLEVEL",  "The requested isolation level is not valid or supported."
  Data.l $8004D009: Data$ "XACT_E_NOASYNC",  "The transaction manager doesn't support an asynchronous operation for this method."
  Data.l $8004D00A: Data$ "XACT_E_NOENLIST",  "Unable to enlist in the transaction."
  Data.l $8004D00B: Data$ "XACT_E_NOISORETAIN",  "The requested semantics of retention of isolation across retaining commit and abort boundaries cannot be supported by this transaction implementation, or isoFlags was not equal to zero."
  Data.l $8004D00C: Data$ "XACT_E_NORESOURCE",  "There is no resource presently associated with this enlistment"
  Data.l $8004D00D: Data$ "XACT_E_NOTCURRENT",  "The transaction failed to commit due to the failure of optimistic concurrency control in at least one of the resource managers."
  Data.l $8004D00E: Data$ "XACT_E_NOTRANSACTION",  "The transaction has already been implicitly or explicitly committed or aborted"
  Data.l $8004D00F: Data$ "XACT_E_NOTSUPPORTED",  "An invalid combination of flags was specified"
  Data.l $8004D010: Data$ "XACT_E_UNKNOWNRMGRID",  "The resource manager id is not associated with this transaction or the transaction manager."
  Data.l $8004D011: Data$ "XACT_E_WRONGSTATE",  "This method was called in the wrong state"
  Data.l $8004D012: Data$ "XACT_E_WRONGUOW",  "The indicated unit of work does not match the unit of work expected by the resource manager."
  Data.l $8004D013: Data$ "XACT_E_XTIONEXISTS",  "An enlistment in a transaction already exists."
  Data.l $8004D014: Data$ "XACT_E_NOIMPORTOBJECT",  "An import object for the transaction could not be found."
  Data.l $8004D015: Data$ "XACT_E_INVALIDCOOKIE",  "The transaction cookie is invalid."
  Data.l $8004D016: Data$ "XACT_E_INDOUBT",  "The transaction status is in doubt. A communication failure occurred, or a transaction manager or resource manager has failed"
  Data.l $8004D017: Data$ "XACT_E_NOTIMEOUT",  "A time-out was specified, but time-outs are not supported."
  Data.l $8004D018: Data$ "XACT_E_ALREADYINPROGRESS",  "The requested operation is already in progress for the transaction."
  Data.l $8004D019: Data$ "XACT_E_ABORTED",  "The transaction has already been aborted."
  Data.l $8004D01A: Data$ "XACT_E_LOGFULL",  "The Transaction Manager returned a log full error."
  Data.l $8004D01B: Data$ "XACT_E_TMNOTAVAILABLE",  "The Transaction Manager is not available."
  Data.l $8004D01C: Data$ "XACT_E_CONNECTION_DOWN",  "A connection with the transaction manager was lost."
  Data.l $8004D01D: Data$ "XACT_E_CONNECTION_DENIED",  "A request to establish a connection with the transaction manager was denied."
  Data.l $8004D01E: Data$ "XACT_E_REENLISTTIMEOUT",  "Resource manager reenlistment to determine transaction status timed out."
  Data.l $8004D01F: Data$ "XACT_E_TIP_CONNECT_FAILED",  "This transaction manager failed to establish a connection with another TIP transaction manager."
  Data.l $8004D020: Data$ "XACT_E_TIP_PROTOCOL_ERROR",  "This transaction manager encountered a protocol error with another TIP transaction manager."
  Data.l $8004D021: Data$ "XACT_E_TIP_PULL_FAILED",  "This transaction manager could not propagate a transaction from another TIP transaction manager."
  Data.l $8004D022: Data$ "XACT_E_DEST_TMNOTAVAILABLE",  "The Transaction Manager on the destination machine is not available."
  Data.l $8004D023: Data$ "XACT_E_TIP_DISABLED",  "The Transaction Manager has disabled its support for TIP."
  Data.l $8004D024: Data$ "XACT_E_NETWORK_TX_DISABLED",  "The transaction manager has disabled its support for remote/network transactions."
  Data.l $8004D025: Data$ "XACT_E_PARTNER_NETWORK_TX_DISABLED",  "The partner transaction manager has disabled its support for remote/network transactions."
  Data.l $8004D026: Data$ "XACT_E_XA_TX_DISABLED",  "The transaction manager has disabled its support for XA transactions."
  Data.l $8004D027: Data$ "XACT_E_UNABLE_TO_READ_DTC_CONFIG",  "MSDTC was unable to read its configuration information."
  Data.l $8004D028: Data$ "XACT_E_UNABLE_TO_LOAD_DTC_PROXY",  "MSDTC was unable to load the dtc proxy dll."
  Data.l $8004D029: Data$ "XACT_E_ABORTING",  "The local transaction has aborted."
  Data.l $8004D080: Data$ "XACT_E_CLERKNOTFOUND",  "XACT_E_CLERKNOTFOUND"
  Data.l $8004D081: Data$ "XACT_E_CLERKEXISTS",  "XACT_E_CLERKEXISTS"
  Data.l $8004D082: Data$ "XACT_E_RECOVERYINPROGRESS",  "XACT_E_RECOVERYINPROGRESS"
  Data.l $8004D083: Data$ "XACT_E_TRANSACTIONCLOSED",  "XACT_E_TRANSACTIONCLOSED"
  Data.l $8004D084: Data$ "XACT_E_INVALIDLSN",  "XACT_E_INVALIDLSN"
  Data.l $8004D085: Data$ "XACT_E_REPLAYREQUEST",  "XACT_E_REPLAYREQUEST"
  Data.l $0004D000: Data$ "XACT_S_ASYNC",  "An asynchronous operation was specified. The operation has begun, but its outcome is not known yet."
  Data.l $0004D001: Data$ "XACT_S_DEFECT",  "XACT_S_DEFECT"
  Data.l $0004D002: Data$ "XACT_S_READONLY",  "The method call succeeded because the transaction was read-only."
  Data.l $0004D003: Data$ "XACT_S_SOMENORETAIN",  "The transaction was successfully aborted. However, this is a coordinated transaction, and some number of enlisted resources were aborted outright because they could not support abort-retaining semantics"
  Data.l $0004D004: Data$ "XACT_S_OKINFORM",  "No changes were made during this call, but the sink wants another chance to look if any other sinks make further changes."
  Data.l $0004D005: Data$ "XACT_S_MADECHANGESCONTENT",  "The sink is content and wishes the transaction to proceed. Changes were made to one or more resources during this call."
  Data.l $0004D006: Data$ "XACT_S_MADECHANGESINFORM",  "The sink is for the moment and wishes the transaction to proceed, but if other changes are made following this return by other event sinks then this sink wants another chance to look"
  Data.l $0004D007: Data$ "XACT_S_ALLNORETAIN",  "The transaction was successfully aborted. However, the abort was non-retaining."
  Data.l $0004D008: Data$ "XACT_S_ABORTING",  "An abort operation was already in progress."
  Data.l $0004D009: Data$ "XACT_S_SINGLEPHASE",  "The resource manager has performed a single-phase commit of the transaction."
  Data.l $0004D00A: Data$ "XACT_S_LOCALLY_OK",  "The local transaction has not aborted."
  Data.l $0004D010: Data$ "XACT_S_LASTRESOURCEMANAGER",  "The resource manager has requested to be the coordinator (last resource manager) for the transaction."
  Data.l $8004E002: Data$ "CONTEXT_E_ABORTED",  "The root transaction wanted to commit, but transaction aborted"
  Data.l $8004E003: Data$ "CONTEXT_E_ABORTING",  "You made a method call on a COM+ component that has a transaction that has already aborted or in the process of aborting."
  Data.l $8004E004: Data$ "CONTEXT_E_NOCONTEXT",  "There is no MTS object context"
  Data.l $8004E005: Data$ "CONTEXT_E_WOULD_DEADLOCK",  "The component is configured to use synchronization and this method call would cause a deadlock to occur."
  Data.l $8004E006: Data$ "CONTEXT_E_SYNCH_TIMEOUT",  "The component is configured to use synchronization and a thread has timed out waiting to enter the context."
  Data.l $8004E007: Data$ "CONTEXT_E_OLDREF",  "You made a method call on a COM+ component that has a transaction that has already committed or aborted."
  Data.l $8004E00C: Data$ "CONTEXT_E_ROLENOTFOUND",  "The specified role was not configured for the application"
  Data.l $8004E00F: Data$ "CONTEXT_E_TMNOTAVAILABLE",  "COM+ was unable to talk to the Microsoft Distributed Transaction Coordinator"
  Data.l $8004E021: Data$ "CO_E_ACTIVATIONFAILED",  "An unexpected error occurred during COM+ Activation."
  Data.l $8004E022: Data$ "CO_E_ACTIVATIONFAILED_EVENTLOGGED",  "COM+ Activation failed. Check the event log for more information"
  Data.l $8004E023: Data$ "CO_E_ACTIVATIONFAILED_CATALOGERROR",  "COM+ Activation failed due to a catalog or configuration error."
  Data.l $8004E024: Data$ "CO_E_ACTIVATIONFAILED_TIMEOUT",  "COM+ activation failed because the activation could not be completed in the specified amount of time."
  Data.l $8004E025: Data$ "CO_E_INITIALIZATIONFAILED",  "COM+ Activation failed because an initialization function failed.  Check the event log for more information."
  Data.l $8004E026: Data$ "CONTEXT_E_NOJIT",  "The requested operation requires that JIT be in the current context and it is not"
  Data.l $8004E027: Data$ "CONTEXT_E_NOTRANSACTION",  "The requested operation requires that the current context have a Transaction, and it does not"
  Data.l $8004E028: Data$ "CO_E_THREADINGMODEL_CHANGED",  "The components threading model has changed after install into a COM+ Application.  Please re-install component."
  Data.l $8004E029: Data$ "CO_E_NOIISINTRINSICS",  "IIS intrinsics not available.  Start your work with IIS."
  Data.l $8004E02A: Data$ "CO_E_NOCOOKIES",  "An attempt to write a cookie failed."
  Data.l $8004E02B: Data$ "CO_E_DBERROR",  "An attempt to use a database generated a database specific error."
  Data.l $8004E02C: Data$ "CO_E_NOTPOOLED",  "The COM+ component you created must use object pooling to work."
  Data.l $8004E02D: Data$ "CO_E_NOTCONSTRUCTED",  "The COM+ component you created must use object construction to work correctly."
  Data.l $8004E02E: Data$ "CO_E_NOSYNCHRONIZATION",  "The COM+ component requires synchronization, and it is not configured for it."
  Data.l $8004E02F: Data$ "CO_E_ISOLEVELMISMATCH",  "The TxIsolation Level property for the COM+ component being created is stronger than the TxIsolationLevel for the 'root' component for the transaction.  The creation failed."
  Data.l $00040000: Data$ "OLE_S_USEREG",  "Use the registry database to provide the requested information"
  Data.l $00040001: Data$ "OLE_S_STATIC",  "Success, but static"
  Data.l $00040002: Data$ "OLE_S_MAC_CLIPFORMAT",  "Macintosh clipboard format"
  Data.l $00040100: Data$ "DRAGDROP_S_DROP",  "Successful drop took place"
  Data.l $00040101: Data$ "DRAGDROP_S_CANCEL",  "Drag-drop operation canceled"
  Data.l $00040102: Data$ "DRAGDROP_S_USEDEFAULTCURSORS",  "Use the default cursor"
  Data.l $00040130: Data$ "DATA_S_SAMEFORMATETC",  "Data has same FORMATETC"
  Data.l $00040140: Data$ "VIEW_S_ALREADY_FROZEN",  "View is already frozen"
  Data.l $00040170: Data$ "CACHE_S_FORMATETC_NOTSUPPORTED",  "FORMATETC not supported"
  Data.l $00040171: Data$ "CACHE_S_SAMECACHE",  "Same cache"
  Data.l $00040172: Data$ "CACHE_S_SOMECACHES_NOTUPDATED",  "Some cache(s) not updated"
  Data.l $00040180: Data$ "OLEOBJ_S_INVALIDVERB",  "Invalid verb for OLE object"
  Data.l $00040181: Data$ "OLEOBJ_S_CANNOT_DOVERB_NOW",  "Verb number is valid but verb cannot be done now"
  Data.l $00040182: Data$ "OLEOBJ_S_INVALIDHWND",  "Invalid window handle passed"
  Data.l $000401A0: Data$ "INPLACE_S_TRUNCATED",  "Message is too long; some of it had to be truncated before displaying"
  Data.l $000401C0: Data$ "CONVERT10_S_NO_PRESENTATION",  "Unable to convert OLESTREAM to IStorage"
  Data.l $000401E2: Data$ "MK_S_REDUCED_TO_SELF",  "Moniker reduced to itself"
  Data.l $000401E4: Data$ "MK_S_ME",  "Common prefix is this moniker"
  Data.l $000401E5: Data$ "MK_S_HIM",  "Common prefix is input moniker"
  Data.l $000401E6: Data$ "MK_S_US",  "Common prefix is both monikers"
  Data.l $000401E7: Data$ "MK_S_MONIKERALREADYREGISTERED",  "Moniker is already registered in running object table"
  Data.l $00041300: Data$ "SCHED_S_TASK_READY",  "The task is ready to run at its next scheduled time."
  Data.l $00041301: Data$ "SCHED_S_TASK_RUNNING",  "The task is currently running."
  Data.l $00041302: Data$ "SCHED_S_TASK_DISABLED",  "The task will not run at the scheduled times because it has been disabled."
  Data.l $00041303: Data$ "SCHED_S_TASK_HAS_NOT_RUN",  "The task has not yet run."
  Data.l $00041304: Data$ "SCHED_S_TASK_NO_MORE_RUNS",  "There are no more runs scheduled for this task."
  Data.l $00041305: Data$ "SCHED_S_TASK_NOT_SCHEDULED",  "One or more of the properties that are needed to run this task on a schedule have not been set."
  Data.l $00041306: Data$ "SCHED_S_TASK_TERMINATED",  "The last run of the task was terminated by the user."
  Data.l $00041307: Data$ "SCHED_S_TASK_NO_VALID_TRIGGERS",  "Either the task has no triggers or the existing triggers are disabled or not set."
  Data.l $00041308: Data$ "SCHED_S_EVENT_TRIGGER",  "Event triggers don't have set run times."
  Data.l $80041309: Data$ "SCHED_E_TRIGGER_NOT_FOUND",  "Trigger not found."
  Data.l $8004130A: Data$ "SCHED_E_TASK_NOT_READY",  "One or more of the properties that are needed to run this task have not been set."
  Data.l $8004130B: Data$ "SCHED_E_TASK_NOT_RUNNING",  "There is no running instance of the task to terminate."
  Data.l $8004130C: Data$ "SCHED_E_SERVICE_NOT_INSTALLED",  "The Task Scheduler Service is not installed on this computer."
  Data.l $8004130D: Data$ "SCHED_E_CANNOT_OPEN_TASK",  "The task object could not be opened."
  Data.l $8004130E: Data$ "SCHED_E_INVALID_TASK",  "The object is either an invalid task object or is not a task object."
  Data.l $8004130F: Data$ "SCHED_E_ACCOUNT_INFORMATION_NOT_SET",  "No account information could be found in the Task Scheduler security database for the task indicated."
  Data.l $80041310: Data$ "SCHED_E_ACCOUNT_NAME_NOT_FOUND",  "Unable to establish existence of the account specified."
  Data.l $80041311: Data$ "SCHED_E_ACCOUNT_DBASE_CORRUPT",  "Corruption was detected in the Task Scheduler security database; the database has been reset."
  Data.l $80041312: Data$ "SCHED_E_NO_SECURITY_SERVICES",  "Task Scheduler security services are available only on Windows NT."
  Data.l $80041313: Data$ "SCHED_E_UNKNOWN_OBJECT_VERSION",  "The task object version is either unsupported or invalid."
  Data.l $80041314: Data$ "SCHED_E_UNSUPPORTED_ACCOUNT_OPTION",  "The task has been configured with an unsupported combination of account settings and run time options."
  Data.l $80041315: Data$ "SCHED_E_SERVICE_NOT_RUNNING",  "The Task Scheduler Service is not running."
  Data.l $80080001: Data$ "CO_E_CLASS_CREATE_FAILED",  "Attempt to create a class object failed"
  Data.l $80080002: Data$ "CO_E_SCM_ERROR",  "OLE service could not bind object"
  Data.l $80080003: Data$ "CO_E_SCM_RPC_FAILURE",  "RPC communication failed with OLE service"
  Data.l $80080004: Data$ "CO_E_BAD_PATH",  "Bad path to object"
  Data.l $80080005: Data$ "CO_E_SERVER_EXEC_FAILURE",  "Server execution failed"
  Data.l $80080006: Data$ "CO_E_OBJSRV_RPC_FAILURE",  "OLE service could not communicate with the object server"
  Data.l $80080007: Data$ "MK_E_NO_NORMALIZED",  "Moniker path could not be normalized"
  Data.l $80080008: Data$ "CO_E_SERVER_STOPPING",  "Object server is stopping when OLE service contacts it"
  Data.l $80080009: Data$ "MEM_E_INVALID_ROOT",  "An invalid root block pointer was specified"
  Data.l $80080010: Data$ "MEM_E_INVALID_LINK",  "An allocation chain contained an invalid link pointer"
  Data.l $80080011: Data$ "MEM_E_INVALID_SIZE",  "The requested allocation size was too large"
  Data.l $00080012: Data$ "CO_S_NOTALLINTERFACES",  "Not all the requested interfaces were available"
  Data.l $00080013: Data$ "CO_S_MACHINENAMENOTFOUND",  "The specified machine name was not found in the cache."
  Data.l $80020001: Data$ "DISP_E_UNKNOWNINTERFACE",  "Unknown interface."
  Data.l $80020003: Data$ "DISP_E_MEMBERNOTFOUND",  "Member not found."
  Data.l $80020004: Data$ "DISP_E_PARAMNOTFOUND",  "Parameter not found."
  Data.l $80020005: Data$ "DISP_E_TYPEMISMATCH",  "Type mismatch."
  Data.l $80020006: Data$ "DISP_E_UNKNOWNNAME",  "Unknown name."
  Data.l $80020007: Data$ "DISP_E_NONAMEDARGS",  "No named arguments."
  Data.l $80020008: Data$ "DISP_E_BADVARTYPE",  "Bad variable type."
  Data.l $80020009: Data$ "DISP_E_EXCEPTION",  "Exception occurred."
  Data.l $8002000A: Data$ "DISP_E_OVERFLOW",  "Out of present range."
  Data.l $8002000B: Data$ "DISP_E_BADINDEX",  "Invalid index."
  Data.l $8002000C: Data$ "DISP_E_UNKNOWNLCID",  "Unknown language."
  Data.l $8002000D: Data$ "DISP_E_ARRAYISLOCKED",  "Memory is locked."
  Data.l $8002000E: Data$ "DISP_E_BADPARAMCOUNT",  "Invalid number of parameters."
  Data.l $8002000F: Data$ "DISP_E_PARAMNOTOPTIONAL",  "Parameter not optional."
  Data.l $80020010: Data$ "DISP_E_BADCALLEE",  "Invalid callee."
  Data.l $80020011: Data$ "DISP_E_NOTACOLLECTION",  "Does not support a collection."
  Data.l $80020012: Data$ "DISP_E_DIVBYZERO",  "Division by zero."
  Data.l $80020013: Data$ "DISP_E_BUFFERTOOSMALL",  "Buffer too small"
  Data.l $80028016: Data$ "TYPE_E_BUFFERTOOSMALL",  "Buffer too small."
  Data.l $80028017: Data$ "TYPE_E_FIELDNOTFOUND",  "Field name not defined in the record."
  Data.l $80028018: Data$ "TYPE_E_INVDATAREAD",  "Old format or invalid type library."
  Data.l $80028019: Data$ "TYPE_E_UNSUPFORMAT",  "Old format or invalid type library."
  Data.l $8002801C: Data$ "TYPE_E_REGISTRYACCESS",  "Error accessing the OLE registry."
  Data.l $8002801D: Data$ "TYPE_E_LIBNOTREGISTERED",  "Library not registered."
  Data.l $80028027: Data$ "TYPE_E_UNDEFINEDTYPE",  "Bound to unknown type."
  Data.l $80028028: Data$ "TYPE_E_QUALIFIEDNAMEDISALLOWED",  "Qualified name disallowed."
  Data.l $80028029: Data$ "TYPE_E_INVALIDSTATE",  "Invalid forward reference, or reference to uncompiled type."
  Data.l $8002802A: Data$ "TYPE_E_WRONGTYPEKIND",  "Type mismatch."
  Data.l $8002802B: Data$ "TYPE_E_ELEMENTNOTFOUND",  "Element not found."
  Data.l $8002802C: Data$ "TYPE_E_AMBIGUOUSNAME",  "Ambiguous name."
  Data.l $8002802D: Data$ "TYPE_E_NAMECONFLICT",  "Name already exists in the library."
  Data.l $8002802E: Data$ "TYPE_E_UNKNOWNLCID",  "Unknown LCID."
  Data.l $8002802F: Data$ "TYPE_E_DLLFUNCTIONNOTFOUND",  "Function not defined in specified DLL."
  Data.l $800288BD: Data$ "TYPE_E_BADMODULEKIND",  "Wrong module kind for the operation."
  Data.l $800288C5: Data$ "TYPE_E_SIZETOOBIG",  "Size may not exceed 64K."
  Data.l $800288C6: Data$ "TYPE_E_DUPLICATEID",  "Duplicate ID in inheritance hierarchy."
  Data.l $800288CF: Data$ "TYPE_E_INVALIDID",  "Incorrect inheritance depth in standard OLE hmember."
  Data.l $80028CA0: Data$ "TYPE_E_TYPEMISMATCH",  "Type mismatch."
  Data.l $80028CA1: Data$ "TYPE_E_OUTOFBOUNDS",  "Invalid number of arguments."
  Data.l $80028CA2: Data$ "TYPE_E_IOERROR",  "I/O Error."
  Data.l $80028CA3: Data$ "TYPE_E_CANTCREATETMPFILE",  "Error creating unique tmp file."
  Data.l $80029C4A: Data$ "TYPE_E_CANTLOADLIBRARY",  "Error loading type library/DLL."
  Data.l $80029C83: Data$ "TYPE_E_INCONSISTENTPROPFUNCS",  "Inconsistent property functions."
  Data.l $80029C84: Data$ "TYPE_E_CIRCULARTYPE",  "Circular dependency between types/modules."
  Data.l $80030001: Data$ "STG_E_INVALIDFUNCTION",  "Unable to perform requested operation."
  Data.l $80030002: Data$ "STG_E_FILENOTFOUND",  "%1 could not be found."
  Data.l $80030003: Data$ "STG_E_PATHNOTFOUND",  "The path %1 could not be found."
  Data.l $80030004: Data$ "STG_E_TOOMANYOPENFILES",  "There are insufficient resources to open another file."
  Data.l $80030005: Data$ "STG_E_ACCESSDENIED",  "Access Denied."
  Data.l $80030006: Data$ "STG_E_INVALIDHANDLE",  "Attempted an operation on an invalid object."
  Data.l $80030008: Data$ "STG_E_INSUFFICIENTMEMORY",  "There is insufficient memory available to complete operation."
  Data.l $80030009: Data$ "STG_E_INVALIDPOINTER",  "Invalid pointer error."
  Data.l $80030012: Data$ "STG_E_NOMOREFILES",  "There are no more entries to return."
  Data.l $80030013: Data$ "STG_E_DISKISWRITEPROTECTED",  "Disk is write-protected."
  Data.l $80030019: Data$ "STG_E_SEEKERROR",  "An error occurred during a seek operation."
  Data.l $8003001D: Data$ "STG_E_WRITEFAULT",  "A disk error occurred during a write operation."
  Data.l $8003001E: Data$ "STG_E_READFAULT",  "A disk error occurred during a read operation."
  Data.l $80030020: Data$ "STG_E_SHAREVIOLATION",  "A share violation has occurred."
  Data.l $80030021: Data$ "STG_E_LOCKVIOLATION",  "A lock violation has occurred."
  Data.l $80030050: Data$ "STG_E_FILEALREADYEXISTS",  "%1 already exists."
  Data.l $80030057: Data$ "STG_E_INVALIDPARAMETER",  "Invalid parameter error."
  Data.l $80030070: Data$ "STG_E_MEDIUMFULL",  "There is insufficient disk space to complete operation."
  Data.l $800300F0: Data$ "STG_E_PROPSETMISMATCHED",  "Illegal write of non-simple property to simple property set."
  Data.l $800300FA: Data$ "STG_E_ABNORMALAPIEXIT",  "An API call exited abnormally."
  Data.l $800300FB: Data$ "STG_E_INVALIDHEADER",  "The file %1 is not a valid compound file."
  Data.l $800300FC: Data$ "STG_E_INVALIDNAME",  "The name %1 is not valid."
  Data.l $800300FD: Data$ "STG_E_UNKNOWN",  "An unexpected error occurred."
  Data.l $800300FE: Data$ "STG_E_UNIMPLEMENTEDFUNCTION",  "That function is not implemented."
  Data.l $800300FF: Data$ "STG_E_INVALIDFLAG",  "Invalid flag error."
  Data.l $80030100: Data$ "STG_E_INUSE",  "Attempted to use an object that is busy."
  Data.l $80030101: Data$ "STG_E_NOTCURRENT",  "The storage has been changed since the last commit."
  Data.l $80030102: Data$ "STG_E_REVERTED",  "Attempted to use an object that has ceased to exist."
  Data.l $80030103: Data$ "STG_E_CANTSAVE",  "Can't save."
  Data.l $80030104: Data$ "STG_E_OLDFORMAT",  "The compound file %1 was produced with an incompatible version of storage."
  Data.l $80030105: Data$ "STG_E_OLDDLL",  "The compound file %1 was produced with a newer version of storage."
  Data.l $80030106: Data$ "STG_E_SHAREREQUIRED",  "Share.exe or equivalent is required for operation."
  Data.l $80030107: Data$ "STG_E_NOTFILEBASEDSTORAGE",  "Illegal operation called on non-file based storage."
  Data.l $80030108: Data$ "STG_E_EXTANTMARSHALLINGS",  "Illegal operation called on object with extant marshallings."
  Data.l $80030109: Data$ "STG_E_DOCFILECORRUPT",  "The docfile has been corrupted."
  Data.l $80030110: Data$ "STG_E_BADBASEADDRESS",  "OLE32.DLL has been loaded at the wrong address."
  Data.l $80030111: Data$ "STG_E_DOCFILETOOLARGE",  "The compound file is too large for the current implementation"
  Data.l $80030112: Data$ "STG_E_NOTSIMPLEFORMAT",  "The compound file was not created with the STGM_SIMPLE flag"
  Data.l $80030201: Data$ "STG_E_INCOMPLETE",  "The file download was aborted abnormally.  The file is incomplete."
  Data.l $80030202: Data$ "STG_E_TERMINATED",  "The file download has been terminated."
  Data.l $00030200: Data$ "STG_S_CONVERTED",  "The underlying file was converted to compound file format."
  Data.l $00030201: Data$ "STG_S_BLOCK",  "The storage operation should block until more data is available."
  Data.l $00030202: Data$ "STG_S_RETRYNOW",  "The storage operation should retry immediately."
  Data.l $00030203: Data$ "STG_S_MONITORING",  "The notified event sink will not influence the storage operation."
  Data.l $00030204: Data$ "STG_S_MULTIPLEOPENS",  "Multiple opens prevent consolidated. (commit succeeded)."
  Data.l $00030205: Data$ "STG_S_CONSOLIDATIONFAILED",  "Consolidation of the storage file failed. (commit succeeded)."
  Data.l $00030206: Data$ "STG_S_CANNOTCONSOLIDATE",  "Consolidation of the storage file is inappropriate. (commit succeeded)."
  Data.l $80030305: Data$ "STG_E_STATUS_COPY_PROTECTION_FAILURE",  "Generic Copy Protection Error."
  Data.l $80030306: Data$ "STG_E_CSS_AUTHENTICATION_FAILURE",  "Copy Protection Error - DVD CSS Authentication failed."
  Data.l $80030307: Data$ "STG_E_CSS_KEY_NOT_PRESENT",  "Copy Protection Error - The given sector does not have a valid CSS key."
  Data.l $80030308: Data$ "STG_E_CSS_KEY_NOT_ESTABLISHED",  "Copy Protection Error - DVD session key not established."
  Data.l $80030309: Data$ "STG_E_CSS_SCRAMBLED_SECTOR",  "Copy Protection Error - The read failed because the sector is encrypted."
  Data.l $8003030A: Data$ "STG_E_CSS_REGION_MISMATCH",  "Copy Protection Error - The current DVD's region does not correspond to the region setting of the drive."
  Data.l $8003030B: Data$ "STG_E_RESETS_EXHAUSTED",  "Copy Protection Error - The drive's region setting may be permanent or the number of user resets has been exhausted."
  Data.l $80010001: Data$ "RPC_E_CALL_REJECTED",  "Call was rejected by callee."
  Data.l $80010002: Data$ "RPC_E_CALL_CANCELED",  "Call was canceled by the message filter."
  Data.l $80010003: Data$ "RPC_E_CANTPOST_INSENDCALL",  "The caller is dispatching an intertask SendMessage call and cannot call out via PostMessage."
  Data.l $80010004: Data$ "RPC_E_CANTCALLOUT_INASYNCCALL",  "The caller is dispatching an asynchronous call and cannot make an outgoing call on behalf of this call."
  Data.l $80010005: Data$ "RPC_E_CANTCALLOUT_INEXTERNALCALL",  "It is illegal to call out while inside message filter."
  Data.l $80010006: Data$ "RPC_E_CONNECTION_TERMINATED",  "The connection terminated or is in a bogus state and cannot be used any more. Other connections are still valid."
  Data.l $80010007: Data$ "RPC_E_SERVER_DIED",  "The callee (server [not server application]) is not available and disappeared; all connections are invalid. The call may have executed."
  Data.l $80010008: Data$ "RPC_E_CLIENT_DIED",  "The caller (client) disappeared while the callee (server) was processing a call."
  Data.l $80010009: Data$ "RPC_E_INVALID_DATAPACKET",  "The data packet with the marshalled parameter data is incorrect."
  Data.l $8001000A: Data$ "RPC_E_CANTTRANSMIT_CALL",  "The call was not transmitted properly; the message queue was full and was not emptied after yielding."
  Data.l $8001000B: Data$ "RPC_E_CLIENT_CANTMARSHAL_DATA",  "The client (caller) cannot marshall the parameter data - low memory, etc."
  Data.l $8001000C: Data$ "RPC_E_CLIENT_CANTUNMARSHAL_DATA",  "The client (caller) cannot unmarshall the return data - low memory, etc."
  Data.l $8001000D: Data$ "RPC_E_SERVER_CANTMARSHAL_DATA",  "The server (callee) cannot marshall the return data - low memory, etc."
  Data.l $8001000E: Data$ "RPC_E_SERVER_CANTUNMARSHAL_DATA",  "The server (callee) cannot unmarshall the parameter data - low memory, etc."
  Data.l $8001000F: Data$ "RPC_E_INVALID_DATA",  "Received data is invalid; could be server or client data."
  Data.l $80010010: Data$ "RPC_E_INVALID_PARAMETER",  "A particular parameter is invalid and cannot be (un)marshalled."
  Data.l $80010011: Data$ "RPC_E_CANTCALLOUT_AGAIN",  "There is no second outgoing call on same channel in DDE conversation."
  Data.l $80010012: Data$ "RPC_E_SERVER_DIED_DNE",  "The callee (server [not server application]) is not available and disappeared; all connections are invalid. The call did not execute."
  Data.l $80010100: Data$ "RPC_E_SYS_CALL_FAILED",  "System call failed."
  Data.l $80010101: Data$ "RPC_E_OUT_OF_RESOURCES",  "Could not allocate some required resource (memory, events, ...)"
  Data.l $80010102: Data$ "RPC_E_ATTEMPTED_MULTITHREAD",  "Attempted to make calls on more than one thread in single threaded mode."
  Data.l $80010103: Data$ "RPC_E_NOT_REGISTERED",  "The requested interface is not registered on the server object."
  Data.l $80010104: Data$ "RPC_E_FAULT",  "RPC could not call the server or could not return the results of calling the server."
  Data.l $80010105: Data$ "RPC_E_SERVERFAULT",  "The server threw an exception."
  Data.l $80010106: Data$ "RPC_E_CHANGED_MODE",  "Cannot change thread mode after it is set."
  Data.l $80010107: Data$ "RPC_E_INVALIDMETHOD",  "The method called does not exist on the server."
  Data.l $80010108: Data$ "RPC_E_DISCONNECTED",  "The object invoked has disconnected from its clients."
  Data.l $80010109: Data$ "RPC_E_RETRY",  "The object invoked chose not to process the call now.  Try again later."
  Data.l $8001010A: Data$ "RPC_E_SERVERCALL_RETRYLATER",  "The message filter indicated that the application is busy."
  Data.l $8001010B: Data$ "RPC_E_SERVERCALL_REJECTED",  "The message filter rejected the call."
  Data.l $8001010C: Data$ "RPC_E_INVALID_CALLDATA",  "A call control interfaces was called with invalid data."
  Data.l $8001010D: Data$ "RPC_E_CANTCALLOUT_ININPUTSYNCCALL",  "An outgoing call cannot be made since the application is dispatching an input-synchronous call."
  Data.l $8001010E: Data$ "RPC_E_WRONG_THREAD",  "The application called an interface that was marshalled for a different thread."
  Data.l $8001010F: Data$ "RPC_E_THREAD_NOT_INIT",  "CoInitialize has not been called on the current thread."
  Data.l $80010110: Data$ "RPC_E_VERSION_MISMATCH",  "The version of OLE on the client and server machines does not match."
  Data.l $80010111: Data$ "RPC_E_INVALID_HEADER",  "OLE received a packet with an invalid header."
  Data.l $80010112: Data$ "RPC_E_INVALID_EXTENSION",  "OLE received a packet with an invalid extension."
  Data.l $80010113: Data$ "RPC_E_INVALID_IPID",  "The requested object or interface does not exist."
  Data.l $80010114: Data$ "RPC_E_INVALID_OBJECT",  "The requested object does not exist."
  Data.l $80010115: Data$ "RPC_S_CALLPENDING",  "OLE has sent a request and is waiting for a reply."
  Data.l $80010116: Data$ "RPC_S_WAITONTIMER",  "OLE is waiting before retrying a request."
  Data.l $80010117: Data$ "RPC_E_CALL_COMPLETE",  "Call context cannot be accessed after call completed."
  Data.l $80010118: Data$ "RPC_E_UNSECURE_CALL",  "Impersonate on unsecure calls is not supported."
  Data.l $80010119: Data$ "RPC_E_TOO_LATE",  "Security must be initialized before any interfaces are marshalled or unmarshalled. It cannot be changed once initialized."
  Data.l $8001011A: Data$ "RPC_E_NO_GOOD_SECURITY_PACKAGES",  "No security packages are installed on this machine or the user is not logged on or there are no compatible security packages between the client and server."
  Data.l $8001011B: Data$ "RPC_E_ACCESS_DENIED",  "Access is denied."
  Data.l $8001011C: Data$ "RPC_E_REMOTE_DISABLED",  "Remote calls are not allowed for this process."
  Data.l $8001011D: Data$ "RPC_E_INVALID_OBJREF",  "The marshaled interface data packet (OBJREF) has an invalid or unknown format."
  Data.l $8001011E: Data$ "RPC_E_NO_CONTEXT",  "No context is associated with this call. This happens for some custom marshalled calls and on the client side of the call."
  Data.l $8001011F: Data$ "RPC_E_TIMEOUT",  "This operation returned because the timeout period expired."
  Data.l $80010120: Data$ "RPC_E_NO_SYNC",  "There are no synchronize objects to wait on."
  Data.l $80010121: Data$ "RPC_E_FULLSIC_REQUIRED",  "Full subject issuer chain SSL principal name expected from the server."
  Data.l $80010122: Data$ "RPC_E_INVALID_STD_NAME",  "Principal name is not a valid MSSTD name."
  Data.l $80010123: Data$ "CO_E_FAILEDTOIMPERSONATE",  "Unable to impersonate DCOM client"
  Data.l $80010124: Data$ "CO_E_FAILEDTOGETSECCTX",  "Unable to obtain server's security context"
  Data.l $80010125: Data$ "CO_E_FAILEDTOOPENTHREADTOKEN",  "Unable to open the access token of the current thread"
  Data.l $80010126: Data$ "CO_E_FAILEDTOGETTOKENINFO",  "Unable to obtain user info from an access token"
  Data.l $80010127: Data$ "CO_E_TRUSTEEDOESNTMATCHCLIENT",  "The client who called IAccessControl::IsAccessPermitted was not the trustee provided to the method"
  Data.l $80010128: Data$ "CO_E_FAILEDTOQUERYCLIENTBLANKET",  "Unable to obtain the client's security blanket"
  Data.l $80010129: Data$ "CO_E_FAILEDTOSETDACL",  "Unable to set a discretionary ACL into a security descriptor"
  Data.l $8001012A: Data$ "CO_E_ACCESSCHECKFAILED",  "The system function, AccessCheck, returned false"
  Data.l $8001012B: Data$ "CO_E_NETACCESSAPIFAILED",  "Either NetAccessDel or NetAccessAdd returned an error code."
  Data.l $8001012C: Data$ "CO_E_WRONGTRUSTEENAMESYNTAX",  "One of the trustee strings provided by the user did not conform to the <Domain>\<Name> syntax and it was not the '*' string"
  Data.l $8001012D: Data$ "CO_E_INVALIDSID",  "One of the security identifiers provided by the user was invalid"
  Data.l $8001012E: Data$ "CO_E_CONVERSIONFAILED",  "Unable to convert a wide character trustee string to a multibyte trustee string"
  Data.l $8001012F: Data$ "CO_E_NOMATCHINGSIDFOUND",  "Unable to find a security identifier that corresponds to a trustee string provided by the user"
  Data.l $80010130: Data$ "CO_E_LOOKUPACCSIDFAILED",  "The system function, LookupAccountSID, failed"
  Data.l $80010131: Data$ "CO_E_NOMATCHINGNAMEFOUND",  "Unable to find a trustee name that corresponds to a security identifier provided by the user"
  Data.l $80010132: Data$ "CO_E_LOOKUPACCNAMEFAILED",  "The system function, LookupAccountName, failed"
  Data.l $80010133: Data$ "CO_E_SETSERLHNDLFAILED",  "Unable to set or reset a serialization handle"
  Data.l $80010134: Data$ "CO_E_FAILEDTOGETWINDIR",  "Unable to obtain the Windows directory"
  Data.l $80010135: Data$ "CO_E_PATHTOOLONG",  "Path too long"
  Data.l $80010136: Data$ "CO_E_FAILEDTOGENUUID",  "Unable to generate a uuid."
  Data.l $80010137: Data$ "CO_E_FAILEDTOCREATEFILE",  "Unable to create file"
  Data.l $80010138: Data$ "CO_E_FAILEDTOCLOSEHANDLE",  "Unable to close a serialization handle or a file handle."
  Data.l $80010139: Data$ "CO_E_EXCEEDSYSACLLIMIT",  "The number of ACEs in an ACL exceeds the system limit."
  Data.l $8001013A: Data$ "CO_E_ACESINWRONGORDER",  "Not all the DENY_ACCESS ACEs are arranged in front of the GRANT_ACCESS ACEs in the stream."
  Data.l $8001013B: Data$ "CO_E_INCOMPATIBLESTREAMVERSION",  "The version of ACL format in the stream is not supported by this implementation of IAccessControl"
  Data.l $8001013C: Data$ "CO_E_FAILEDTOOPENPROCESSTOKEN",  "Unable to open the access token of the server process"
  Data.l $8001013D: Data$ "CO_E_DECODEFAILED",  "Unable to decode the ACL in the stream provided by the user"
  Data.l $8001013F: Data$ "CO_E_ACNOTINITIALIZED",  "The COM IAccessControl object is not initialized"
  Data.l $80010140: Data$ "CO_E_CANCEL_DISABLED",  "Call Cancellation is disabled"
  Data.l $8001FFFF: Data$ "RPC_E_UNEXPECTED",  "An internal error occurred."
  Data.l $C0090001: Data$ "ERROR_AUDITING_DISABLED",  "The specified event is currently not being audited."
  Data.l $C0090002: Data$ "ERROR_ALL_SIDS_FILTERED",  "The SID filtering operation removed all SIDs."
  Data.l $80090001: Data$ "NTE_BAD_UID",  "Bad UID."
  Data.l $80090002: Data$ "NTE_BAD_HASH",  "Bad Hash."
  Data.l $80090003: Data$ "NTE_BAD_KEY",  "Bad Key."
  Data.l $80090004: Data$ "NTE_BAD_LEN",  "Bad Length."
  Data.l $80090005: Data$ "NTE_BAD_DATA",  "Bad Data."
  Data.l $80090006: Data$ "NTE_BAD_SIGNATURE",  "Invalid Signature."
  Data.l $80090007: Data$ "NTE_BAD_VER",  "Bad Version of provider."
  Data.l $80090008: Data$ "NTE_BAD_ALGID",  "Invalid algorithm specified."
  Data.l $80090009: Data$ "NTE_BAD_FLAGS",  "Invalid flags specified."
  Data.l $8009000A: Data$ "NTE_BAD_TYPE",  "Invalid type specified."
  Data.l $8009000B: Data$ "NTE_BAD_KEY_STATE",  "Key not valid for use in specified state."
  Data.l $8009000C: Data$ "NTE_BAD_HASH_STATE",  "Hash not valid for use in specified state."
  Data.l $8009000D: Data$ "NTE_NO_KEY",  "Key does not exist."
  Data.l $8009000E: Data$ "NTE_NO_MEMORY",  "Insufficient memory available for the operation."
  Data.l $8009000F: Data$ "NTE_EXISTS",  "Object already exists."
  Data.l $80090010: Data$ "NTE_PERM",  "Access denied."
  Data.l $80090011: Data$ "NTE_NOT_FOUND",  "Object was not found."
  Data.l $80090012: Data$ "NTE_DOUBLE_ENCRYPT",  "Data already encrypted."
  Data.l $80090013: Data$ "NTE_BAD_PROVIDER",  "Invalid provider specified."
  Data.l $80090014: Data$ "NTE_BAD_PROV_TYPE",  "Invalid provider type specified."
  Data.l $80090015: Data$ "NTE_BAD_PUBLIC_KEY",  "Provider's public key is invalid."
  Data.l $80090016: Data$ "NTE_BAD_KEYSET",  "Keyset does not exist"
  Data.l $80090017: Data$ "NTE_PROV_TYPE_NOT_DEF",  "Provider type not defined."
  Data.l $80090018: Data$ "NTE_PROV_TYPE_ENTRY_BAD",  "Provider type as registered is invalid."
  Data.l $80090019: Data$ "NTE_KEYSET_NOT_DEF",  "The keyset is not defined."
  Data.l $8009001A: Data$ "NTE_KEYSET_ENTRY_BAD",  "Keyset as registered is invalid."
  Data.l $8009001B: Data$ "NTE_PROV_TYPE_NO_MATCH",  "Provider type does not match registered value."
  Data.l $8009001C: Data$ "NTE_SIGNATURE_FILE_BAD",  "The digital signature file is corrupt."
  Data.l $8009001D: Data$ "NTE_PROVIDER_DLL_FAIL",  "Provider DLL failed to initialize correctly."
  Data.l $8009001E: Data$ "NTE_PROV_DLL_NOT_FOUND",  "Provider DLL could not be found."
  Data.l $8009001F: Data$ "NTE_BAD_KEYSET_PARAM",  "The Keyset parameter is invalid."
  Data.l $80090020: Data$ "NTE_FAIL",  "An internal error occurred."
  Data.l $80090021: Data$ "NTE_SYS_ERR",  "A base error occurred."
  Data.l $80090022: Data$ "NTE_SILENT_CONTEXT",  "Provider could not perform the action since the context was acquired as silent."
  Data.l $80090023: Data$ "NTE_TOKEN_KEYSET_STORAGE_FULL",  "The security token does not have storage space available for an additional container."
  Data.l $80090024: Data$ "NTE_TEMPORARY_PROFILE",  "The profile for the user is a temporary profile."
  Data.l $80090025: Data$ "NTE_FIXEDPARAMETER",  "The key parameters could not be set because the CSP uses fixed parameters."
  Data.l $80090300: Data$ "SEC_E_INSUFFICIENT_MEMORY",  "Not enough memory is available to complete this request"
  Data.l $80090301: Data$ "SEC_E_INVALID_HANDLE",  "The handle specified is invalid"
  Data.l $80090302: Data$ "SEC_E_UNSUPPORTED_FUNCTION",  "The function requested is not supported"
  Data.l $80090303: Data$ "SEC_E_TARGET_UNKNOWN",  "The specified target is unknown or unreachable"
  Data.l $80090304: Data$ "SEC_E_INTERNAL_ERROR",  "The Local Security Authority cannot be contacted"
  Data.l $80090305: Data$ "SEC_E_SECPKG_NOT_FOUND",  "The requested security package does not exist"
  Data.l $80090306: Data$ "SEC_E_NOT_OWNER",  "The caller is not the owner of the desired credentials"
  Data.l $80090307: Data$ "SEC_E_CANNOT_INSTALL",  "The security package failed to initialize, and cannot be installed"
  Data.l $80090308: Data$ "SEC_E_INVALID_TOKEN",  "The token supplied to the function is invalid"
  Data.l $80090309: Data$ "SEC_E_CANNOT_PACK",  "The security package is not able to marshall the logon buffer, so the logon attempt has failed"
  Data.l $8009030A: Data$ "SEC_E_QOP_NOT_SUPPORTED",  "The per-message Quality of Protection is not supported by the security package"
  Data.l $8009030B: Data$ "SEC_E_NO_IMPERSONATION",  "The security context does not allow impersonation of the client"
  Data.l $8009030C: Data$ "SEC_E_LOGON_DENIED",  "The logon attempt failed"
  Data.l $8009030D: Data$ "SEC_E_UNKNOWN_CREDENTIALS",  "The credentials supplied to the package were not recognized"
  Data.l $8009030E: Data$ "SEC_E_NO_CREDENTIALS",  "No credentials are available in the security package"
  Data.l $8009030F: Data$ "SEC_E_MESSAGE_ALTERED",  "The message or signature supplied for verification has been altered"
  Data.l $80090310: Data$ "SEC_E_OUT_OF_SEQUENCE",  "The message supplied for verification is out of sequence"
  Data.l $80090311: Data$ "SEC_E_NO_AUTHENTICATING_AUTHORITY",  "No authority could be contacted for authentication."
  Data.l $00090312: Data$ "SEC_I_CONTINUE_NEEDED",  "The function completed successfully, but must be called again to complete the context"
  Data.l $00090313: Data$ "SEC_I_COMPLETE_NEEDED",  "The function completed successfully, but CompleteToken must be called"
  Data.l $00090314: Data$ "SEC_I_COMPLETE_AND_CONTINUE",  "The function completed successfully, but both CompleteToken and this function must be called to complete the context"
  Data.l $00090315: Data$ "SEC_I_LOCAL_LOGON",  "The logon was completed, but no network authority was available. The logon was made using locally known information"
  Data.l $80090316: Data$ "SEC_E_BAD_PKGID",  "The requested security package does not exist"
  Data.l $80090317: Data$ "SEC_E_CONTEXT_EXPIRED",  "The context has expired and can no longer be used."
  Data.l $00090317: Data$ "SEC_I_CONTEXT_EXPIRED",  "The context has expired and can no longer be used."
  Data.l $80090318: Data$ "SEC_E_INCOMPLETE_MESSAGE",  "The supplied message is incomplete.  The signature was not verified."
  Data.l $80090320: Data$ "SEC_E_INCOMPLETE_CREDENTIALS",  "The credentials supplied were not complete, and could not be verified. The context could not be initialized."
  Data.l $80090321: Data$ "SEC_E_BUFFER_TOO_SMALL",  "The buffers supplied to a function was too small."
  Data.l $00090320: Data$ "SEC_I_INCOMPLETE_CREDENTIALS",  "The credentials supplied were not complete, and could not be verified. Additional information can be returned from the context."
  Data.l $00090321: Data$ "SEC_I_RENEGOTIATE",  "The context data must be renegotiated with the peer."
  Data.l $80090322: Data$ "SEC_E_WRONG_PRINCIPAL",  "The target principal name is incorrect."
  Data.l $00090323: Data$ "SEC_I_NO_LSA_CONTEXT",  "There is no LSA mode context associated with this context."
  Data.l $80090324: Data$ "SEC_E_TIME_SKEW",  "The clocks on the client and server machines are skewed."
  Data.l $80090325: Data$ "SEC_E_UNTRUSTED_ROOT",  "The certificate chain was issued by an authority that is not trusted."
  Data.l $80090326: Data$ "SEC_E_ILLEGAL_MESSAGE",  "The message received was unexpected or badly formatted."
  Data.l $80090327: Data$ "SEC_E_CERT_UNKNOWN",  "An unknown error occurred while processing the certificate."
  Data.l $80090328: Data$ "SEC_E_CERT_EXPIRED",  "The received certificate has expired."
  Data.l $80090329: Data$ "SEC_E_ENCRYPT_FAILURE",  "The specified data could not be encrypted."
  Data.l $80090331: Data$ "SEC_E_ALGORITHM_MISMATCH",  "The client and server cannot communicate, because they do not possess a common algorithm."
  Data.l $80090332: Data$ "SEC_E_SECURITY_QOS_FAILED",  "The security context could not be established due to a failure in the requested quality of service (e.g. mutual authentication or delegation)."
  Data.l $80090333: Data$ "SEC_E_UNFINISHED_CONTEXT_DELETED",  "A security context was deleted before the context was completed.  This is considered a logon failure."
  Data.l $80090334: Data$ "SEC_E_NO_TGT_REPLY",  "The client is trying to negotiate a context and the server requires user-to-user but didn't send a TGT reply."
  Data.l $80090335: Data$ "SEC_E_NO_IP_ADDRESSES",  "Unable to accomplish the requested task because the local machine does not have any IP addresses."
  Data.l $80090336: Data$ "SEC_E_WRONG_CREDENTIAL_HANDLE",  "The supplied credential handle does not match the credential associated with the security context."
  Data.l $80090337: Data$ "SEC_E_CRYPTO_SYSTEM_INVALID",  "The crypto system or checksum function is invalid because a required function is unavailable."
  Data.l $80090338: Data$ "SEC_E_MAX_REFERRALS_EXCEEDED",  "The number of maximum ticket referrals has been exceeded."
  Data.l $80090339: Data$ "SEC_E_MUST_BE_KDC",  "The local machine must be a Kerberos KDC (domain controller) and it is not."
  Data.l $8009033A: Data$ "SEC_E_STRONG_CRYPTO_NOT_SUPPORTED",  "The other end of the security negotiation is requires strong crypto but it is not supported on the local machine."
  Data.l $8009033B: Data$ "SEC_E_TOO_MANY_PRINCIPALS",  "The KDC reply contained more than one principal name."
  Data.l $8009033C: Data$ "SEC_E_NO_PA_DATA",  "Expected to find PA data for a hint of what etype to use, but it was not found."
  Data.l $8009033E: Data$ "SEC_E_SMARTCARD_LOGON_REQUIRED",  "Smartcard logon is required and was not used."
  Data.l $8009033F: Data$ "SEC_E_SHUTDOWN_IN_PROGRESS",  "A system shutdown is in progress."
  Data.l $80090340: Data$ "SEC_E_KDC_INVALID_REQUEST",  "An invalid request was sent to the KDC."
  Data.l $80090341: Data$ "SEC_E_KDC_UNABLE_TO_REFER",  "The KDC was unable to generate a referral for the service requested."
  Data.l $80090342: Data$ "SEC_E_KDC_UNKNOWN_ETYPE",  "The encryption type requested is not supported by the KDC."
  Data.l $80090343: Data$ "SEC_E_UNSUPPORTED_PREAUTH",  "An unsupported preauthentication mechanism was presented to the kerberos package."
  Data.l $80090345: Data$ "SEC_E_DELEGATION_REQUIRED",  "The requested operation cannot be completed.  The computer must be trusted for delegation and the current user account must be configured to allow delegation."
  Data.l $80090346: Data$ "SEC_E_BAD_BINDINGS",  "Client's supplied SSPI channel bindings were incorrect."
  Data.l $80090347: Data$ "SEC_E_MULTIPLE_ACCOUNTS",  "The received certificate was mapped to multiple accounts."
  Data.l $80090348: Data$ "SEC_E_NO_KERB_KEY",  "SEC_E_NO_KERB_KEY"
  Data.l $80090349: Data$ "SEC_E_CERT_WRONG_USAGE",  "The certificate is not valid for the requested usage."
  Data.l $80090350: Data$ "SEC_E_DOWNGRADE_DETECTED",  "The system detected a possible attempt to compromise security.  Please ensure that you can contact the server that authenticated you."
  Data.l $80091001: Data$ "CRYPT_E_MSG_ERROR",  "An error occurred while performing an operation on a cryptographic message."
  Data.l $80091002: Data$ "CRYPT_E_UNKNOWN_ALGO",  "Unknown cryptographic algorithm."
  Data.l $80091003: Data$ "CRYPT_E_OID_FORMAT",  "The object identifier is poorly formatted."
  Data.l $80091004: Data$ "CRYPT_E_INVALID_MSG_TYPE",  "Invalid cryptographic message type."
  Data.l $80091005: Data$ "CRYPT_E_UNEXPECTED_ENCODING",  "Unexpected cryptographic message encoding."
  Data.l $80091006: Data$ "CRYPT_E_AUTH_ATTR_MISSING",  "The cryptographic message does not contain an expected authenticated attribute."
  Data.l $80091007: Data$ "CRYPT_E_HASH_VALUE",  "The hash value is not correct."
  Data.l $80091008: Data$ "CRYPT_E_INVALID_INDEX",  "The index value is not valid."
  Data.l $80091009: Data$ "CRYPT_E_ALREADY_DECRYPTED",  "The content of the cryptographic message has already been decrypted."
  Data.l $8009100A: Data$ "CRYPT_E_NOT_DECRYPTED",  "The content of the cryptographic message has not been decrypted yet."
  Data.l $8009100B: Data$ "CRYPT_E_RECIPIENT_NOT_FOUND",  "The enveloped-data message does not contain the specified recipient."
  Data.l $8009100C: Data$ "CRYPT_E_CONTROL_TYPE",  "Invalid control type."
  Data.l $8009100D: Data$ "CRYPT_E_ISSUER_SERIALNUMBER",  "Invalid issuer and/or serial number."
  Data.l $8009100E: Data$ "CRYPT_E_SIGNER_NOT_FOUND",  "Cannot find the original signer."
  Data.l $8009100F: Data$ "CRYPT_E_ATTRIBUTES_MISSING",  "The cryptographic message does not contain all of the requested attributes."
  Data.l $80091010: Data$ "CRYPT_E_STREAM_MSG_NOT_READY",  "The streamed cryptographic message is not ready to return data."
  Data.l $80091011: Data$ "CRYPT_E_STREAM_INSUFFICIENT_DATA",  "The streamed cryptographic message requires more data to complete the decode operation."
  Data.l $00091012: Data$ "CRYPT_I_NEW_PROTECTION_REQUIRED",  "The protected data needs to be re-protected."
  Data.l $80092001: Data$ "CRYPT_E_BAD_LEN",  "The length specified for the output data was insufficient."
  Data.l $80092002: Data$ "CRYPT_E_BAD_ENCODE",  "An error occurred during encode or decode operation."
  Data.l $80092003: Data$ "CRYPT_E_FILE_ERROR",  "An error occurred while reading or writing to a file."
  Data.l $80092004: Data$ "CRYPT_E_NOT_FOUND",  "Cannot find object or property."
  Data.l $80092005: Data$ "CRYPT_E_EXISTS",  "The object or property already exists."
  Data.l $80092006: Data$ "CRYPT_E_NO_PROVIDER",  "No provider was specified for the store or object."
  Data.l $80092007: Data$ "CRYPT_E_SELF_SIGNED",  "The specified certificate is self signed."
  Data.l $80092008: Data$ "CRYPT_E_DELETED_PREV",  "The previous certificate or CRL context was deleted."
  Data.l $80092009: Data$ "CRYPT_E_NO_MATCH",  "Cannot find the requested object."
  Data.l $8009200A: Data$ "CRYPT_E_UNEXPECTED_MSG_TYPE",  "The certificate does not have a property that references a private key."
  Data.l $8009200B: Data$ "CRYPT_E_NO_KEY_PROPERTY",  "Cannot find the certificate and private key for decryption."
  Data.l $8009200C: Data$ "CRYPT_E_NO_DECRYPT_CERT",  "Cannot find the certificate and private key to use for decryption."
  Data.l $8009200D: Data$ "CRYPT_E_BAD_MSG",  "Not a cryptographic message or the cryptographic message is not formatted correctly."
  Data.l $8009200E: Data$ "CRYPT_E_NO_SIGNER",  "The signed cryptographic message does not have a signer for the specified signer index."
  Data.l $8009200F: Data$ "CRYPT_E_PENDING_CLOSE",  "Final closure is pending until additional frees or closes."
  Data.l $80092010: Data$ "CRYPT_E_REVOKED",  "The certificate is revoked."
  Data.l $80092011: Data$ "CRYPT_E_NO_REVOCATION_DLL",  "No Dll or exported function was found to verify revocation."
  Data.l $80092012: Data$ "CRYPT_E_NO_REVOCATION_CHECK",  "The revocation function was unable to check revocation for the certificate."
  Data.l $80092013: Data$ "CRYPT_E_REVOCATION_OFFLINE",  "The revocation function was unable to check revocation because the revocation server was offline."
  Data.l $80092014: Data$ "CRYPT_E_NOT_IN_REVOCATION_DATABASE",  "The certificate is not in the revocation server's database."
  Data.l $80092020: Data$ "CRYPT_E_INVALID_NUMERIC_STRING",  "The string contains a non-numeric character."
  Data.l $80092021: Data$ "CRYPT_E_INVALID_PRINTABLE_STRING",  "The string contains a non-printable character."
  Data.l $80092022: Data$ "CRYPT_E_INVALID_IA5_STRING",  "The string contains a character not in the 7 bit ASCII character set."
  Data.l $80092023: Data$ "CRYPT_E_INVALID_X500_STRING",  "The string contains an invalid X500 name attribute key, oid, value or delimiter."
  Data.l $80092024: Data$ "CRYPT_E_NOT_CHAR_STRING",  "The dwValueType for the CERT_NAME_VALUE is not one of the character strings.  Most likely it is either a CERT_RDN_ENCODED_BLOB or CERT_TDN_OCTED_STRING."
  Data.l $80092025: Data$ "CRYPT_E_FILERESIZED",  "The Put operation can not continue.  The file needs to be resized.  However, there is already a signature present.  A complete signing operation must be done."
  Data.l $80092026: Data$ "CRYPT_E_SECURITY_SETTINGS",  "The cryptographic operation failed due to a local security option setting."
  Data.l $80092027: Data$ "CRYPT_E_NO_VERIFY_USAGE_DLL",  "No DLL or exported function was found to verify subject usage."
  Data.l $80092028: Data$ "CRYPT_E_NO_VERIFY_USAGE_CHECK",  "The called function was unable to do a usage check on the subject."
  Data.l $80092029: Data$ "CRYPT_E_VERIFY_USAGE_OFFLINE",  "Since the server was offline, the called function was unable to complete the usage check."
  Data.l $8009202A: Data$ "CRYPT_E_NOT_IN_CTL",  "The subject was not found in a Certificate Trust List (CTL)."
  Data.l $8009202B: Data$ "CRYPT_E_NO_TRUSTED_SIGNER",  "None of the signers of the cryptographic message or certificate trust list is trusted."
  Data.l $8009202C: Data$ "CRYPT_E_MISSING_PUBKEY_PARA",  "The public key's algorithm parameters are missing."
  Data.l $80093001: Data$ "OSS_MORE_BUF",  "OSS ASN.1 Error: Output Buffer is too small."
  Data.l $80093002: Data$ "OSS_NEGATIVE_UINTEGER",  "OSS ASN.1 Error: Signed integer is encoded as a unsigned integer."
  Data.l $80093003: Data$ "OSS_PDU_RANGE",  "OSS ASN.1 Error: Unknown ASN.1 data type."
  Data.l $80093004: Data$ "OSS_MORE_INPUT",  "OSS ASN.1 Error: Output buffer is too small, the decoded data has been truncated."
  Data.l $80093005: Data$ "OSS_DATA_ERROR",  "OSS ASN.1 Error: Invalid data."
  Data.l $80093006: Data$ "OSS_BAD_ARG",  "OSS ASN.1 Error: Invalid argument."
  Data.l $80093007: Data$ "OSS_BAD_VERSION",  "OSS ASN.1 Error: Encode/Decode version mismatch."
  Data.l $80093008: Data$ "OSS_OUT_MEMORY",  "OSS ASN.1 Error: Out of memory."
  Data.l $80093009: Data$ "OSS_PDU_MISMATCH",  "OSS ASN.1 Error: Encode/Decode Error."
  Data.l $8009300A: Data$ "OSS_LIMITED",  "OSS ASN.1 Error: Internal Error."
  Data.l $8009300B: Data$ "OSS_BAD_PTR",  "OSS ASN.1 Error: Invalid data."
  Data.l $8009300C: Data$ "OSS_BAD_TIME",  "OSS ASN.1 Error: Invalid data."
  Data.l $8009300D: Data$ "OSS_INDEFINITE_NOT_SUPPORTED",  "OSS ASN.1 Error: Unsupported BER indefinite-length encoding."
  Data.l $8009300E: Data$ "OSS_MEM_ERROR",  "OSS ASN.1 Error: Access violation."
  Data.l $8009300F: Data$ "OSS_BAD_TABLE",  "OSS ASN.1 Error: Invalid data."
  Data.l $80093010: Data$ "OSS_TOO_LONG",  "OSS ASN.1 Error: Invalid data."
  Data.l $80093011: Data$ "OSS_CONSTRAINT_VIOLATED",  "OSS ASN.1 Error: Invalid data."
  Data.l $80093012: Data$ "OSS_FATAL_ERROR",  "OSS ASN.1 Error: Internal Error."
  Data.l $80093013: Data$ "OSS_ACCESS_SERIALIZATION_ERROR",  "OSS ASN.1 Error: Multi-threading conflict."
  Data.l $80093014: Data$ "OSS_NULL_TBL",  "OSS ASN.1 Error: Invalid data."
  Data.l $80093015: Data$ "OSS_NULL_FCN",  "OSS ASN.1 Error: Invalid data."
  Data.l $80093016: Data$ "OSS_BAD_ENCRULES",  "OSS ASN.1 Error: Invalid data."
  Data.l $80093017: Data$ "OSS_UNAVAIL_ENCRULES",  "OSS ASN.1 Error: Encode/Decode function not implemented."
  Data.l $80093018: Data$ "OSS_CANT_OPEN_TRACE_WINDOW",  "OSS ASN.1 Error: Trace file error."
  Data.l $80093019: Data$ "OSS_UNIMPLEMENTED",  "OSS ASN.1 Error: Function not implemented."
  Data.l $8009301A: Data$ "OSS_OID_DLL_NOT_LINKED",  "OSS ASN.1 Error: Program link error."
  Data.l $8009301B: Data$ "OSS_CANT_OPEN_TRACE_FILE",  "OSS ASN.1 Error: Trace file error."
  Data.l $8009301C: Data$ "OSS_TRACE_FILE_ALREADY_OPEN",  "OSS ASN.1 Error: Trace file error."
  Data.l $8009301D: Data$ "OSS_TABLE_MISMATCH",  "OSS ASN.1 Error: Invalid data."
  Data.l $8009301E: Data$ "OSS_TYPE_NOT_SUPPORTED",  "OSS ASN.1 Error: Invalid data."
  Data.l $8009301F: Data$ "OSS_REAL_DLL_NOT_LINKED",  "OSS ASN.1 Error: Program link error."
  Data.l $80093020: Data$ "OSS_REAL_CODE_NOT_LINKED",  "OSS ASN.1 Error: Program link error."
  Data.l $80093021: Data$ "OSS_OUT_OF_RANGE",  "OSS ASN.1 Error: Program link error."
  Data.l $80093022: Data$ "OSS_COPIER_DLL_NOT_LINKED",  "OSS ASN.1 Error: Program link error."
  Data.l $80093023: Data$ "OSS_CONSTRAINT_DLL_NOT_LINKED",  "OSS ASN.1 Error: Program link error."
  Data.l $80093024: Data$ "OSS_COMPARATOR_DLL_NOT_LINKED",  "OSS ASN.1 Error: Program link error."
  Data.l $80093025: Data$ "OSS_COMPARATOR_CODE_NOT_LINKED",  "OSS ASN.1 Error: Program link error."
  Data.l $80093026: Data$ "OSS_MEM_MGR_DLL_NOT_LINKED",  "OSS ASN.1 Error: Program link error."
  Data.l $80093027: Data$ "OSS_PDV_DLL_NOT_LINKED",  "OSS ASN.1 Error: Program link error."
  Data.l $80093028: Data$ "OSS_PDV_CODE_NOT_LINKED",  "OSS ASN.1 Error: Program link error."
  Data.l $80093029: Data$ "OSS_API_DLL_NOT_LINKED",  "OSS ASN.1 Error: Program link error."
  Data.l $8009302A: Data$ "OSS_BERDER_DLL_NOT_LINKED",  "OSS ASN.1 Error: Program link error."
  Data.l $8009302B: Data$ "OSS_PER_DLL_NOT_LINKED",  "OSS ASN.1 Error: Program link error."
  Data.l $8009302C: Data$ "OSS_OPEN_TYPE_ERROR",  "OSS ASN.1 Error: Program link error."
  Data.l $8009302D: Data$ "OSS_MUTEX_NOT_CREATED",  "OSS ASN.1 Error: System resource error."
  Data.l $8009302E: Data$ "OSS_CANT_CLOSE_TRACE_FILE",  "OSS ASN.1 Error: Trace file error."
  Data.l $80093101: Data$ "CRYPT_E_ASN1_INTERNAL",  "ASN1 internal encode or decode error."
  Data.l $80093102: Data$ "CRYPT_E_ASN1_EOD",  "ASN1 unexpected end of data."
  Data.l $80093103: Data$ "CRYPT_E_ASN1_CORRUPT",  "ASN1 corrupted data."
  Data.l $80093104: Data$ "CRYPT_E_ASN1_LARGE",  "ASN1 value too large."
  Data.l $80093105: Data$ "CRYPT_E_ASN1_CONSTRAINT",  "ASN1 constraint violated."
  Data.l $80093106: Data$ "CRYPT_E_ASN1_MEMORY",  "ASN1 out of memory."
  Data.l $80093107: Data$ "CRYPT_E_ASN1_OVERFLOW",  "ASN1 buffer overflow."
  Data.l $80093108: Data$ "CRYPT_E_ASN1_BADPDU",  "ASN1 function not supported for this PDU."
  Data.l $80093109: Data$ "CRYPT_E_ASN1_BADARGS",  "ASN1 bad arguments to function call."
  Data.l $8009310A: Data$ "CRYPT_E_ASN1_BADREAL",  "ASN1 bad real value."
  Data.l $8009310B: Data$ "CRYPT_E_ASN1_BADTAG",  "ASN1 bad tag value met."
  Data.l $8009310C: Data$ "CRYPT_E_ASN1_CHOICE",  "ASN1 bad choice value."
  Data.l $8009310D: Data$ "CRYPT_E_ASN1_RULE",  "ASN1 bad encoding rule."
  Data.l $8009310E: Data$ "CRYPT_E_ASN1_UTF8",  "ASN1 bad unicode (UTF8)."
  Data.l $80093133: Data$ "CRYPT_E_ASN1_PDU_TYPE",  "ASN1 bad PDU type."
  Data.l $80093134: Data$ "CRYPT_E_ASN1_NYI",  "ASN1 not yet implemented."
  Data.l $80093201: Data$ "CRYPT_E_ASN1_EXTENDED",  "ASN1 skipped unknown extension(s)."
  Data.l $80093202: Data$ "CRYPT_E_ASN1_NOEOD",  "ASN1 end of data expected"
  Data.l $80094001: Data$ "CERTSRV_E_BAD_REQUESTSUBJECT",  "The request subject name is invalid or too long."
  Data.l $80094002: Data$ "CERTSRV_E_NO_REQUEST",  "The request does not exist."
  Data.l $80094003: Data$ "CERTSRV_E_BAD_REQUESTSTATUS",  "The request's current status does not allow this operation."
  Data.l $80094004: Data$ "CERTSRV_E_PROPERTY_EMPTY",  "The requested property value is empty."
  Data.l $80094005: Data$ "CERTSRV_E_INVALID_CA_CERTIFICATE",  "The certification authority's certificate contains invalid data."
  Data.l $80094006: Data$ "CERTSRV_E_SERVER_SUSPENDED",  "Certificate service has been suspended for a database restore operation."
  Data.l $80094007: Data$ "CERTSRV_E_ENCODING_LENGTH",  "The certificate contains an encoded length that is potentially incompatible with older enrollment software."
  Data.l $80094008: Data$ "CERTSRV_E_ROLECONFLICT",  "The operation is denied. The user has multiple roles assigned and the certification authority is configured to enforce role separation."
  Data.l $80094009: Data$ "CERTSRV_E_RESTRICTEDOFFICER",  "The operation is denied. It can only be performed by a certificate manager that is allowed to manage certificates for the current requester."
  Data.l $8009400A: Data$ "CERTSRV_E_KEY_ARCHIVAL_NOT_CONFIGURED",  "Cannot archive private key.  The certification authority is not configured for key archival."
  Data.l $8009400B: Data$ "CERTSRV_E_NO_VALID_KRA",  "Cannot archive private key.  The certification authority could not verify one or more key recovery certificates."
  Data.l $8009400C: Data$ "CERTSRV_E_BAD_REQUEST_KEY_ARCHIVAL",  "The request is incorrectly formatted.  The encrypted private key must be in an unauthenticated attribute in an outermost signature."
  Data.l $8009400D: Data$ "CERTSRV_E_NO_CAADMIN_DEFINED",  "At least one security principal must have the permission to manage this CA."
  Data.l $8009400E: Data$ "CERTSRV_E_BAD_RENEWAL_CERT_ATTRIBUTE",  "The request contains an invalid renewal certificate attribute."
  Data.l $8009400F: Data$ "CERTSRV_E_NO_DB_SESSIONS",  "An attempt was made to open a Certification Authority database session, but there are already too many active sessions.  The server may need to be configured to allow additional sessions."
  Data.l $80094010: Data$ "CERTSRV_E_ALIGNMENT_FAULT",  "A memory reference caused a data alignment fault."
  Data.l $80094011: Data$ "CERTSRV_E_ENROLL_DENIED",  "The permissions on this certification authority do not allow the current user to enroll for certificates."
  Data.l $80094012: Data$ "CERTSRV_E_TEMPLATE_DENIED",  "The permissions on the certificate template do not allow the current user to enroll for this type of certificate."
  Data.l $80094013: Data$ "CERTSRV_E_DOWNLEVEL_DC_SSL_OR_UPGRADE",  "The contacted domain controller cannot support signed LDAP traffic.  Update the domain controller or configure Certificate Services to use SSL for Active Directory access."
  Data.l $80094800: Data$ "CERTSRV_E_UNSUPPORTED_CERT_TYPE",  "The requested certificate template is not supported by this CA."
  Data.l $80094801: Data$ "CERTSRV_E_NO_CERT_TYPE",  "The request contains no certificate template information."
  Data.l $80094802: Data$ "CERTSRV_E_TEMPLATE_CONFLICT",  "The request contains conflicting template information."
  Data.l $80094803: Data$ "CERTSRV_E_SUBJECT_ALT_NAME_REQUIRED",  "The request is missing a required Subject Alternate name extension."
  Data.l $80094804: Data$ "CERTSRV_E_ARCHIVED_KEY_REQUIRED",  "The request is missing a required private key for archival by the server."
  Data.l $80094805: Data$ "CERTSRV_E_SMIME_REQUIRED",  "The request is missing a required SMIME capabilities extension."
  Data.l $80094806: Data$ "CERTSRV_E_BAD_RENEWAL_SUBJECT",  "The request was made on behalf of a subject other than the caller.  The certificate template must be configured to require at least one signature to authorize the request."
  Data.l $80094807: Data$ "CERTSRV_E_BAD_TEMPLATE_VERSION",  "The request template version is newer than the supported template version."
  Data.l $80094808: Data$ "CERTSRV_E_TEMPLATE_POLICY_REQUIRED",  "The template is missing a required signature policy attribute."
  Data.l $80094809: Data$ "CERTSRV_E_SIGNATURE_POLICY_REQUIRED",  "The request is missing required signature policy information."
  Data.l $8009480A: Data$ "CERTSRV_E_SIGNATURE_COUNT",  "The request is missing one or more required signatures."
  Data.l $8009480B: Data$ "CERTSRV_E_SIGNATURE_REJECTED",  "One or more signatures did not include the required application or issuance policies.  The request is missing one or more required valid signatures."
  Data.l $8009480C: Data$ "CERTSRV_E_ISSUANCE_POLICY_REQUIRED",  "The request is missing one or more required signature issuance policies."
  Data.l $8009480D: Data$ "CERTSRV_E_SUBJECT_UPN_REQUIRED",  "The UPN is unavailable and cannot be added to the Subject Alternate name."
  Data.l $8009480E: Data$ "CERTSRV_E_SUBJECT_DIRECTORY_GUID_REQUIRED",  "The Active Directory GUID is unavailable and cannot be added to the Subject Alternate name."
  Data.l $8009480F: Data$ "CERTSRV_E_SUBJECT_DNS_REQUIRED",  "The DNS name is unavailable and cannot be added to the Subject Alternate name."
  Data.l $80094810: Data$ "CERTSRV_E_ARCHIVED_KEY_UNEXPECTED",  "The request includes a private key for archival by the server, but key archival is not enabled for the specified certificate template."
  Data.l $80094811: Data$ "CERTSRV_E_KEY_LENGTH",  "The public key does not meet the minimum size required by the specified certificate template."
  Data.l $80094812: Data$ "CERTSRV_E_SUBJECT_EMAIL_REQUIRED",  "The EMail name is unavailable and cannot be added to the Subject or Subject Alternate name."
  Data.l $80094813: Data$ "CERTSRV_E_UNKNOWN_CERT_TYPE",  "One or more certificate templates to be enabled on this certification authority could not be found."
  Data.l $80094814: Data$ "CERTSRV_E_CERT_TYPE_OVERLAP",  "The certificate template renewal period is longer than the certificate validity period.  The template should be reconfigured or the CA certificate renewed."
  Data.l $80095000: Data$ "XENROLL_E_KEY_NOT_EXPORTABLE",  "The key is not exportable."
  Data.l $80095001: Data$ "XENROLL_E_CANNOT_ADD_ROOT_CERT",  "You cannot add the root CA certificate into your local store."
  Data.l $80095002: Data$ "XENROLL_E_RESPONSE_KA_HASH_NOT_FOUND",  "The key archival hash attribute was not found in the response."
  Data.l $80095003: Data$ "XENROLL_E_RESPONSE_UNEXPECTED_KA_HASH",  "An unexpected key archival hash attribute was found in the response."
  Data.l $80095004: Data$ "XENROLL_E_RESPONSE_KA_HASH_MISMATCH",  "There is a key archival hash mismatch between the request and the response."
  Data.l $80095005: Data$ "XENROLL_E_KEYSPEC_SMIME_MISMATCH",  "Signing certificate cannot include SMIME extension."
  Data.l $80096001: Data$ "TRUST_E_SYSTEM_ERROR",  "A system-level error occurred while verifying trust."
  Data.l $80096002: Data$ "TRUST_E_NO_SIGNER_CERT",  "The certificate for the signer of the message is invalid or not found."
  Data.l $80096003: Data$ "TRUST_E_COUNTER_SIGNER",  "One of the counter signatures was invalid."
  Data.l $80096004: Data$ "TRUST_E_CERT_SIGNATURE",  "The signature of the certificate can not be verified."
  Data.l $80096005: Data$ "TRUST_E_TIME_STAMP",  "The timestamp signature and/or certificate could not be verified or is malformed."
  Data.l $80096010: Data$ "TRUST_E_BAD_DIGEST",  "The digital signature of the object did not verify."
  Data.l $80096019: Data$ "TRUST_E_BASIC_CONSTRAINTS",  "A certificate's basic constraint extension has not been observed."
  Data.l $8009601E: Data$ "TRUST_E_FINANCIAL_CRITERIA",  "The certificate does not meet or contain the Authenticode(tm) financial extensions."
  Data.l $80097001: Data$ "MSSIPOTF_E_OUTOFMEMRANGE",  "Tried to reference a part of the file outside the proper range."
  Data.l $80097002: Data$ "MSSIPOTF_E_CANTGETOBJECT",  "Could not retrieve an object from the file."
  Data.l $80097003: Data$ "MSSIPOTF_E_NOHEADTABLE",  "Could not find the head table in the file."
  Data.l $80097004: Data$ "MSSIPOTF_E_BAD_MAGICNUMBER",  "The magic number in the head table is incorrect."
  Data.l $80097005: Data$ "MSSIPOTF_E_BAD_OFFSET_TABLE",  "The offset table has incorrect values."
  Data.l $80097006: Data$ "MSSIPOTF_E_TABLE_TAGORDER",  "Duplicate table tags or tags out of alphabetical order."
  Data.l $80097007: Data$ "MSSIPOTF_E_TABLE_LONGWORD",  "A table does not start on a long word boundary."
  Data.l $80097008: Data$ "MSSIPOTF_E_BAD_FIRST_TABLE_PLACEMENT",  "First table does not appear after header information."
  Data.l $80097009: Data$ "MSSIPOTF_E_TABLES_OVERLAP",  "Two or more tables overlap."
  Data.l $8009700A: Data$ "MSSIPOTF_E_TABLE_PADBYTES",  "Too many pad bytes between tables or pad bytes are not 0."
  Data.l $8009700B: Data$ "MSSIPOTF_E_FILETOOSMALL",  "File is too small to contain the last table."
  Data.l $8009700C: Data$ "MSSIPOTF_E_TABLE_CHECKSUM",  "A table checksum is incorrect."
  Data.l $8009700D: Data$ "MSSIPOTF_E_FILE_CHECKSUM",  "The file checksum is incorrect."
  Data.l $80097010: Data$ "MSSIPOTF_E_FAILED_POLICY",  "The signature does not have the correct attributes for the policy."
  Data.l $80097011: Data$ "MSSIPOTF_E_FAILED_HINTS_CHECK",  "The file did not pass the hints check."
  Data.l $80097012: Data$ "MSSIPOTF_E_NOT_OPENTYPE",  "The file is not an OpenType file."
  Data.l $80097013: Data$ "MSSIPOTF_E_FILE",  "Failed on a file operation (open, map, read, write)."
  Data.l $80097014: Data$ "MSSIPOTF_E_CRYPT",  "A call to a CryptoAPI function failed."
  Data.l $80097015: Data$ "MSSIPOTF_E_BADVERSION",  "There is a bad version number in the file."
  Data.l $80097016: Data$ "MSSIPOTF_E_DSIG_STRUCTURE",  "The structure of the DSIG table is incorrect."
  Data.l $80097017: Data$ "MSSIPOTF_E_PCONST_CHECK",  "A check failed in a partially constant table."
  Data.l $80097018: Data$ "MSSIPOTF_E_STRUCTURE",  "Some kind of structural error."
  Data.l $800B0001: Data$ "TRUST_E_PROVIDER_UNKNOWN",  "Unknown trust provider."
  Data.l $800B0002: Data$ "TRUST_E_ACTION_UNKNOWN",  "The trust verification action specified is not supported by the specified trust provider."
  Data.l $800B0003: Data$ "TRUST_E_SUBJECT_FORM_UNKNOWN",  "The form specified for the subject is not one supported or known by the specified trust provider."
  Data.l $800B0004: Data$ "TRUST_E_SUBJECT_NOT_TRUSTED",  "The subject is not trusted for the specified action."
  Data.l $800B0005: Data$ "DIGSIG_E_ENCODE",  "Error due to problem in ASN.1 encoding process."
  Data.l $800B0006: Data$ "DIGSIG_E_DECODE",  "Error due to problem in ASN.1 decoding process."
  Data.l $800B0007: Data$ "DIGSIG_E_EXTENSIBILITY",  "Reading / writing Extensions where Attributes are appropriate, and visa versa."
  Data.l $800B0008: Data$ "DIGSIG_E_CRYPTO",  "Unspecified cryptographic failure."
  Data.l $800B0009: Data$ "PERSIST_E_SIZEDEFINITE",  "The size of the data could not be determined."
  Data.l $800B000A: Data$ "PERSIST_E_SIZEINDEFINITE",  "The size of the indefinite-sized data could not be determined."
  Data.l $800B000B: Data$ "PERSIST_E_NOTSELFSIZING",  "This object does not read and write self-sizing data."
  Data.l $800B0100: Data$ "TRUST_E_NOSIGNATURE",  "No signature was present in the subject."
  Data.l $800B0101: Data$ "CERT_E_EXPIRED",  "A required certificate is not within its validity period when verifying against the current system clock or the timestamp in the signed file."
  Data.l $800B0102: Data$ "CERT_E_VALIDITYPERIODNESTING",  "The validity periods of the certification chain do not nest correctly."
  Data.l $800B0103: Data$ "CERT_E_ROLE",  "A certificate that can only be used as an end-entity is being used as a CA or visa versa."
  Data.l $800B0104: Data$ "CERT_E_PATHLENCONST",  "A path length constraint in the certification chain has been violated."
  Data.l $800B0105: Data$ "CERT_E_CRITICAL",  "A certificate contains an unknown extension that is marked 'critical'."
  Data.l $800B0106: Data$ "CERT_E_PURPOSE",  "A certificate being used for a purpose other than the ones specified by its CA."
  Data.l $800B0107: Data$ "CERT_E_ISSUERCHAINING",  "A parent of a given certificate in fact did not issue that child certificate."
  Data.l $800B0108: Data$ "CERT_E_MALFORMED",  "A certificate is missing or has an empty value for an important field, such as a subject or issuer name."
  Data.l $800B0109: Data$ "CERT_E_UNTRUSTEDROOT",  "A certificate chain processed, but terminated in a root certificate which is not trusted by the trust provider."
  Data.l $800B010A: Data$ "CERT_E_CHAINING",  "A certificate chain could not be built to a trusted root authority."
  Data.l $800B010B: Data$ "TRUST_E_FAIL",  "Generic trust failure."
  Data.l $800B010C: Data$ "CERT_E_REVOKED",  "A certificate was explicitly revoked by its issuer."
  Data.l $800B010D: Data$ "CERT_E_UNTRUSTEDTESTROOT",  "The certification path terminates with the test root which is not trusted with the current policy settings."
  Data.l $800B010E: Data$ "CERT_E_REVOCATION_FAILURE",  "The revocation process could not continue - the certificate(s) could not be checked."
  Data.l $800B010F: Data$ "CERT_E_CN_NO_MATCH",  "The certificate's CN name does not match the passed value."
  Data.l $800B0110: Data$ "CERT_E_WRONG_USAGE",  "The certificate is not valid for the requested usage."
  Data.l $800B0111: Data$ "TRUST_E_EXPLICIT_DISTRUST",  "The certificate was explicitly marked as untrusted by the user."
  Data.l $800B0112: Data$ "CERT_E_UNTRUSTEDCA",  "A certification chain processed correctly, but one of the CA certificates is not trusted by the policy provider."
  Data.l $800B0113: Data$ "CERT_E_INVALID_POLICY",  "The certificate has invalid policy."
  Data.l $800B0114: Data$ "CERT_E_INVALID_NAME",  "The certificate has an invalid name. The name is not included in the permitted list or is explicitly excluded."
  Data.l $800F0000: Data$ "SPAPI_E_EXPECTED_SECTION_NAME",  "A non-empty line was encountered in the INF before the start of a section."
  Data.l $800F0001: Data$ "SPAPI_E_BAD_SECTION_NAME_LINE",  "A section name marker in the INF is not complete, or does not exist on a line by itself."
  Data.l $800F0002: Data$ "SPAPI_E_SECTION_NAME_TOO_LONG",  "An INF section was encountered whose name exceeds the maximum section name length."
  Data.l $800F0003: Data$ "SPAPI_E_GENERAL_SYNTAX",  "The syntax of the INF is invalid."
  Data.l $800F0100: Data$ "SPAPI_E_WRONG_INF_STYLE",  "The style of the INF is different than what was requested."
  Data.l $800F0101: Data$ "SPAPI_E_SECTION_NOT_FOUND",  "The required section was not found in the INF."
  Data.l $800F0102: Data$ "SPAPI_E_LINE_NOT_FOUND",  "The required line was not found in the INF."
  Data.l $800F0103: Data$ "SPAPI_E_NO_BACKUP",  "The files affected by the installation of this file queue have not been backed up for uninstall."
  Data.l $800F0200: Data$ "SPAPI_E_NO_ASSOCIATED_CLASS",  "The INF or the device information set or element does not have an associated install class."
  Data.l $800F0201: Data$ "SPAPI_E_CLASS_MISMATCH",  "The INF or the device information set or element does not match the specified install class."
  Data.l $800F0202: Data$ "SPAPI_E_DUPLICATE_FOUND",  "An existing device was found that is a duplicate of the device being manually installed."
  Data.l $800F0203: Data$ "SPAPI_E_NO_DRIVER_SELECTED",  "There is no driver selected for the device information set or element."
  Data.l $800F0204: Data$ "SPAPI_E_KEY_DOES_NOT_EXIST",  "The requested device registry key does not exist."
  Data.l $800F0205: Data$ "SPAPI_E_INVALID_DEVINST_NAME",  "The device instance name is invalid."
  Data.l $800F0206: Data$ "SPAPI_E_INVALID_CLASS",  "The install class is not present or is invalid."
  Data.l $800F0207: Data$ "SPAPI_E_DEVINST_ALREADY_EXISTS",  "The device instance cannot be created because it already exists."
  Data.l $800F0208: Data$ "SPAPI_E_DEVINFO_NOT_REGISTERED",  "The operation cannot be performed on a device information element that has not been registered."
  Data.l $800F0209: Data$ "SPAPI_E_INVALID_REG_PROPERTY",  "The device property code is invalid."
  Data.l $800F020A: Data$ "SPAPI_E_NO_INF",  "The INF from which a driver list is to be built does not exist."
  Data.l $800F020B: Data$ "SPAPI_E_NO_SUCH_DEVINST",  "The device instance does not exist in the hardware tree."
  Data.l $800F020C: Data$ "SPAPI_E_CANT_LOAD_CLASS_ICON",  "The icon representing this install class cannot be loaded."
  Data.l $800F020D: Data$ "SPAPI_E_INVALID_CLASS_INSTALLER",  "The class installer registry entry is invalid."
  Data.l $800F020E: Data$ "SPAPI_E_DI_DO_DEFAULT",  "The class installer has indicated that the default action should be performed for this installation request."
  Data.l $800F020F: Data$ "SPAPI_E_DI_NOFILECOPY",  "The operation does not require any files to be copied."
  Data.l $800F0210: Data$ "SPAPI_E_INVALID_HWPROFILE",  "The specified hardware profile does not exist."
  Data.l $800F0211: Data$ "SPAPI_E_NO_DEVICE_SELECTED",  "There is no device information element currently selected for this device information set."
  Data.l $800F0212: Data$ "SPAPI_E_DEVINFO_LIST_LOCKED",  "The operation cannot be performed because the device information set is locked."
  Data.l $800F0213: Data$ "SPAPI_E_DEVINFO_DATA_LOCKED",  "The operation cannot be performed because the device information element is locked."
  Data.l $800F0214: Data$ "SPAPI_E_DI_BAD_PATH",  "The specified path does not contain any applicable device INFs."
  Data.l $800F0215: Data$ "SPAPI_E_NO_CLASSINSTALL_PARAMS",  "No class installer parameters have been set for the device information set or element."
  Data.l $800F0216: Data$ "SPAPI_E_FILEQUEUE_LOCKED",  "The operation cannot be performed because the file queue is locked."
  Data.l $800F0217: Data$ "SPAPI_E_BAD_SERVICE_INSTALLSECT",  "A service installation section in this INF is invalid."
  Data.l $800F0218: Data$ "SPAPI_E_NO_CLASS_DRIVER_LIST",  "There is no class driver list for the device information element."
  Data.l $800F0219: Data$ "SPAPI_E_NO_ASSOCIATED_SERVICE",  "The installation failed because a function driver was not specified for this device instance."
  Data.l $800F021A: Data$ "SPAPI_E_NO_DEFAULT_DEVICE_INTERFACE",  "There is presently no default device interface designated for this interface class."
  Data.l $800F021B: Data$ "SPAPI_E_DEVICE_INTERFACE_ACTIVE",  "The operation cannot be performed because the device interface is currently active."
  Data.l $800F021C: Data$ "SPAPI_E_DEVICE_INTERFACE_REMOVED",  "The operation cannot be performed because the device interface has been removed from the system."
  Data.l $800F021D: Data$ "SPAPI_E_BAD_INTERFACE_INSTALLSECT",  "An interface installation section in this INF is invalid."
  Data.l $800F021E: Data$ "SPAPI_E_NO_SUCH_INTERFACE_CLASS",  "This interface class does not exist in the system."
  Data.l $800F021F: Data$ "SPAPI_E_INVALID_REFERENCE_STRING",  "The reference string supplied for this interface device is invalid."
  Data.l $800F0220: Data$ "SPAPI_E_INVALID_MACHINENAME",  "The specified machine name does not conform to UNC naming conventions."
  Data.l $800F0221: Data$ "SPAPI_E_REMOTE_COMM_FAILURE",  "A general remote communication error occurred."
  Data.l $800F0222: Data$ "SPAPI_E_MACHINE_UNAVAILABLE",  "The machine selected for remote communication is not available at this time."
  Data.l $800F0223: Data$ "SPAPI_E_NO_CONFIGMGR_SERVICES",  "The Plug and Play service is not available on the remote machine."
  Data.l $800F0224: Data$ "SPAPI_E_INVALID_PROPPAGE_PROVIDER",  "The property page provider registry entry is invalid."
  Data.l $800F0225: Data$ "SPAPI_E_NO_SUCH_DEVICE_INTERFACE",  "The requested device interface is not present in the system."
  Data.l $800F0226: Data$ "SPAPI_E_DI_POSTPROCESSING_REQUIRED",  "The device's co-installer has additional work to perform after installation is complete."
  Data.l $800F0227: Data$ "SPAPI_E_INVALID_COINSTALLER",  "The device's co-installer is invalid."
  Data.l $800F0228: Data$ "SPAPI_E_NO_COMPAT_DRIVERS",  "There are no compatible drivers for this device."
  Data.l $800F0229: Data$ "SPAPI_E_NO_DEVICE_ICON",  "There is no icon that represents this device or device type."
  Data.l $800F022A: Data$ "SPAPI_E_INVALID_INF_LOGCONFIG",  "A logical configuration specified in this INF is invalid."
  Data.l $800F022B: Data$ "SPAPI_E_DI_DONT_INSTALL",  "The class installer has denied the request to install or upgrade this device."
  Data.l $800F022C: Data$ "SPAPI_E_INVALID_FILTER_DRIVER",  "One of the filter drivers installed for this device is invalid."
  Data.l $800F022D: Data$ "SPAPI_E_NON_WINDOWS_NT_DRIVER",  "The driver selected for this device does not support Windows XP."
  Data.l $800F022E: Data$ "SPAPI_E_NON_WINDOWS_DRIVER",  "The driver selected for this device does not support Windows."
  Data.l $800F022F: Data$ "SPAPI_E_NO_CATALOG_FOR_OEM_INF",  "The third-party INF does not contain digital signature information."
  Data.l $800F0230: Data$ "SPAPI_E_DEVINSTALL_QUEUE_NONNATIVE",  "An invalid attempt was made to use a device installation file queue for verification of digital signatures relative to other platforms."
  Data.l $800F0231: Data$ "SPAPI_E_NOT_DISABLEABLE",  "The device cannot be disabled."
  Data.l $800F0232: Data$ "SPAPI_E_CANT_REMOVE_DEVINST",  "The device could not be dynamically removed."
  Data.l $800F0233: Data$ "SPAPI_E_INVALID_TARGET",  "Cannot copy to specified target."
  Data.l $800F0234: Data$ "SPAPI_E_DRIVER_NONNATIVE",  "Driver is not intended for this platform."
  Data.l $800F0235: Data$ "SPAPI_E_IN_WOW64",  "Operation not allowed in WOW64."
  Data.l $800F0236: Data$ "SPAPI_E_SET_SYSTEM_RESTORE_POINT",  "The operation involving unsigned file copying was rolled back, so that a system restore point could be set."
  Data.l $800F0237: Data$ "SPAPI_E_INCORRECTLY_COPIED_INF",  "An INF was copied into the Windows INF directory in an improper manner."
  Data.l $800F0238: Data$ "SPAPI_E_SCE_DISABLED",  "The Security Configuration Editor (SCE) APIs have been disabled on this Embedded product."
  Data.l $800F0239: Data$ "SPAPI_E_UNKNOWN_EXCEPTION",  "An unknown exception was encountered."
  Data.l $800F023A: Data$ "SPAPI_E_PNP_REGISTRY_ERROR",  "A problem was encountered when accessing the Plug and Play registry database."
  Data.l $800F023B: Data$ "SPAPI_E_REMOTE_REQUEST_UNSUPPORTED",  "The requested operation is not supported for a remote machine."
  Data.l $800F023C: Data$ "SPAPI_E_NOT_AN_INSTALLED_OEM_INF",  "The specified file is not an installed OEM INF."
  Data.l $800F023D: Data$ "SPAPI_E_INF_IN_USE_BY_DEVICES",  "One or more devices are presently installed using the specified INF."
  Data.l $800F023E: Data$ "SPAPI_E_DI_FUNCTION_OBSOLETE",  "The requested device install operation is obsolete."
  Data.l $800F023F: Data$ "SPAPI_E_NO_AUTHENTICODE_CATALOG",  "A file could not be verified because it does not have an associated catalog signed via Authenticode(tm)."
  Data.l $800F0240: Data$ "SPAPI_E_AUTHENTICODE_DISALLOWED",  "Authenticode(tm) signature verification is not supported for the specified INF."
  Data.l $800F0241: Data$ "SPAPI_E_AUTHENTICODE_TRUSTED_PUBLISHER",  "The INF was signed with an Authenticode(tm) catalog from a trusted publisher."
  Data.l $800F0242: Data$ "SPAPI_E_AUTHENTICODE_TRUST_NOT_ESTABLISHED",  "The publisher of an Authenticode(tm) signed catalog has not yet been established as trusted."
  Data.l $800F0243: Data$ "SPAPI_E_AUTHENTICODE_PUBLISHER_NOT_TRUSTED",  "The publisher of an Authenticode(tm) signed catalog was not established as trusted."
  Data.l $800F0244: Data$ "SPAPI_E_SIGNATURE_OSATTRIBUTE_MISMATCH",  "The software was tested for compliance with Windows Logo requirements on a different version of Windows, and may not be compatible with this version."
  Data.l $800F0245: Data$ "SPAPI_E_ONLY_VALIDATE_VIA_AUTHENTICODE",  "The file may only be validated by a catalog signed via Authenticode(tm)."
  Data.l $800F0300: Data$ "SPAPI_E_UNRECOVERABLE_STACK_OVERFLOW",  "An unrecoverable stack overflow was encountered."
  Data.l $800F1000: Data$ "SPAPI_E_ERROR_NOT_INSTALLED",  "No installed components were detected."
  Data.l $80100001: Data$ "SCARD_F_INTERNAL_ERROR",  "An internal consistency check failed."
  Data.l $80100002: Data$ "SCARD_E_CANCELLED",  "The action was cancelled by an SCardCancel request."
  Data.l $80100003: Data$ "SCARD_E_INVALID_HANDLE",  "The supplied handle was invalid."
  Data.l $80100004: Data$ "SCARD_E_INVALID_PARAMETER",  "One or more of the supplied parameters could not be properly interpreted."
  Data.l $80100005: Data$ "SCARD_E_INVALID_TARGET",  "Registry startup information is missing or invalid."
  Data.l $80100006: Data$ "SCARD_E_NO_MEMORY",  "Not enough memory available to complete this command."
  Data.l $80100007: Data$ "SCARD_F_WAITED_TOO_LONG",  "An internal consistency timer has expired."
  Data.l $80100008: Data$ "SCARD_E_INSUFFICIENT_BUFFER",  "The data buffer to receive returned data is too small for the returned data."
  Data.l $80100009: Data$ "SCARD_E_UNKNOWN_READER",  "The specified reader name is not recognized."
  Data.l $8010000A: Data$ "SCARD_E_TIMEOUT",  "The user-specified timeout value has expired."
  Data.l $8010000B: Data$ "SCARD_E_SHARING_VIOLATION",  "The smart card cannot be accessed because of other connections outstanding."
  Data.l $8010000C: Data$ "SCARD_E_NO_SMARTCARD",  "The operation requires a Smart Card, but no Smart Card is currently in the device."
  Data.l $8010000D: Data$ "SCARD_E_UNKNOWN_CARD",  "The specified smart card name is not recognized."
  Data.l $8010000E: Data$ "SCARD_E_CANT_DISPOSE",  "The system could not dispose of the media in the requested manner."
  Data.l $8010000F: Data$ "SCARD_E_PROTO_MISMATCH",  "The requested protocols are incompatible with the protocol currently in use with the smart card."
  Data.l $80100010: Data$ "SCARD_E_NOT_READY",  "The reader or smart card is not ready to accept commands."
  Data.l $80100011: Data$ "SCARD_E_INVALID_VALUE",  "One or more of the supplied parameters values could not be properly interpreted."
  Data.l $80100012: Data$ "SCARD_E_SYSTEM_CANCELLED",  "The action was cancelled by the system, presumably to log off or shut down."
  Data.l $80100013: Data$ "SCARD_F_COMM_ERROR",  "An internal communications error has been detected."
  Data.l $80100014: Data$ "SCARD_F_UNKNOWN_ERROR",  "An internal error has been detected, but the source is unknown."
  Data.l $80100015: Data$ "SCARD_E_INVALID_ATR",  "An ATR obtained from the registry is not a valid ATR string."
  Data.l $80100016: Data$ "SCARD_E_NOT_TRANSACTED",  "An attempt was made to end a non-existent transaction."
  Data.l $80100017: Data$ "SCARD_E_READER_UNAVAILABLE",  "The specified reader is not currently available for use."
  Data.l $80100018: Data$ "SCARD_P_SHUTDOWN",  "The operation has been aborted to allow the server application to exit."
  Data.l $80100019: Data$ "SCARD_E_PCI_TOO_SMALL",  "The PCI Receive buffer was too small."
  Data.l $8010001A: Data$ "SCARD_E_READER_UNSUPPORTED",  "The reader driver does not meet minimal requirements for support."
  Data.l $8010001B: Data$ "SCARD_E_DUPLICATE_READER",  "The reader driver did not produce a unique reader name."
  Data.l $8010001C: Data$ "SCARD_E_CARD_UNSUPPORTED",  "The smart card does not meet minimal requirements for support."
  Data.l $8010001D: Data$ "SCARD_E_NO_SERVICE",  "The Smart card resource manager is not running."
  Data.l $8010001E: Data$ "SCARD_E_SERVICE_STOPPED",  "The Smart card resource manager has shut down."
  Data.l $8010001F: Data$ "SCARD_E_UNEXPECTED",  "An unexpected card error has occurred."
  Data.l $80100020: Data$ "SCARD_E_ICC_INSTALLATION",  "No Primary Provider can be found for the smart card."
  Data.l $80100021: Data$ "SCARD_E_ICC_CREATEORDER",  "The requested order of object creation is not supported."
  Data.l $80100022: Data$ "SCARD_E_UNSUPPORTED_FEATURE",  "This smart card does not support the requested feature."
  Data.l $80100023: Data$ "SCARD_E_DIR_NOT_FOUND",  "The identified directory does not exist in the smart card."
  Data.l $80100024: Data$ "SCARD_E_FILE_NOT_FOUND",  "The identified file does not exist in the smart card."
  Data.l $80100025: Data$ "SCARD_E_NO_DIR",  "The supplied path does not represent a smart card directory."
  Data.l $80100026: Data$ "SCARD_E_NO_FILE",  "The supplied path does not represent a smart card file."
  Data.l $80100027: Data$ "SCARD_E_NO_ACCESS",  "Access is denied to this file."
  Data.l $80100028: Data$ "SCARD_E_WRITE_TOO_MANY",  "The smartcard does not have enough memory to store the information."
  Data.l $80100029: Data$ "SCARD_E_BAD_SEEK",  "There was an error trying to set the smart card file object pointer."
  Data.l $8010002A: Data$ "SCARD_E_INVALID_CHV",  "The supplied PIN is incorrect."
  Data.l $8010002B: Data$ "SCARD_E_UNKNOWN_RES_MNG",  "An unrecognized error code was returned from a layered component."
  Data.l $8010002C: Data$ "SCARD_E_NO_SUCH_CERTIFICATE",  "The requested certificate does not exist."
  Data.l $8010002D: Data$ "SCARD_E_CERTIFICATE_UNAVAILABLE",  "The requested certificate could not be obtained."
  Data.l $8010002E: Data$ "SCARD_E_NO_READERS_AVAILABLE",  "Cannot find a smart card reader."
  Data.l $8010002F: Data$ "SCARD_E_COMM_DATA_LOST",  "A communications error with the smart card has been detected.  Retry the operation."
  Data.l $80100030: Data$ "SCARD_E_NO_KEY_CONTAINER",  "The requested key container does not exist on the smart card."
  Data.l $80100031: Data$ "SCARD_E_SERVER_TOO_BUSY",  "The Smart card resource manager is too busy to complete this operation."
  Data.l $80100065: Data$ "SCARD_W_UNSUPPORTED_CARD",  "The reader cannot communicate with the smart card, due to ATR configuration conflicts."
  Data.l $80100066: Data$ "SCARD_W_UNRESPONSIVE_CARD",  "The smart card is not responding to a reset."
  Data.l $80100067: Data$ "SCARD_W_UNPOWERED_CARD",  "Power has been removed from the smart card, so that further communication is not possible."
  Data.l $80100068: Data$ "SCARD_W_RESET_CARD",  "The smart card has been reset, so any shared state information is invalid."
  Data.l $80100069: Data$ "SCARD_W_REMOVED_CARD",  "The smart card has been removed, so that further communication is not possible."
  Data.l $8010006A: Data$ "SCARD_W_SECURITY_VIOLATION",  "Access was denied because of a security violation."
  Data.l $8010006B: Data$ "SCARD_W_WRONG_CHV",  "The card cannot be accessed because the wrong PIN was presented."
  Data.l $8010006C: Data$ "SCARD_W_CHV_BLOCKED",  "The card cannot be accessed because the maximum number of PIN entry attempts has been reached."
  Data.l $8010006D: Data$ "SCARD_W_EOF",  "The end of the smart card file has been reached."
  Data.l $8010006E: Data$ "SCARD_W_CANCELLED_BY_USER",  "The action was cancelled by the user."
  Data.l $8010006F: Data$ "SCARD_W_CARD_NOT_AUTHENTICATED",  "No PIN was presented to the smart card."
  Data.l $80110401: Data$ "COMADMIN_E_OBJECTERRORS",  "Errors occurred accessing one or more objects - the ErrorInfo collection may have more detail"
  Data.l $80110402: Data$ "COMADMIN_E_OBJECTINVALID",  "One or more of the object's properties are missing or invalid"
  Data.l $80110403: Data$ "COMADMIN_E_KEYMISSING",  "The object was not found in the catalog"
  Data.l $80110404: Data$ "COMADMIN_E_ALREADYINSTALLED",  "The object is already registered"
  Data.l $80110407: Data$ "COMADMIN_E_APP_FILE_WRITEFAIL",  "Error occurred writing to the application file"
  Data.l $80110408: Data$ "COMADMIN_E_APP_FILE_READFAIL",  "Error occurred reading the application file"
  Data.l $80110409: Data$ "COMADMIN_E_APP_FILE_VERSION",  "Invalid version number in application file"
  Data.l $8011040A: Data$ "COMADMIN_E_BADPATH",  "The file path is invalid"
  Data.l $8011040B: Data$ "COMADMIN_E_APPLICATIONEXISTS",  "The application is already installed"
  Data.l $8011040C: Data$ "COMADMIN_E_ROLEEXISTS",  "The role already exists"
  Data.l $8011040D: Data$ "COMADMIN_E_CANTCOPYFILE",  "An error occurred copying the file"
  Data.l $8011040F: Data$ "COMADMIN_E_NOUSER",  "One or more users are not valid"
  Data.l $80110410: Data$ "COMADMIN_E_INVALIDUSERIDS",  "One or more users in the application file are not valid"
  Data.l $80110411: Data$ "COMADMIN_E_NOREGISTRYCLSID",  "The component's CLSID is missing or corrupt"
  Data.l $80110412: Data$ "COMADMIN_E_BADREGISTRYPROGID",  "The component's progID is missing or corrupt"
  Data.l $80110413: Data$ "COMADMIN_E_AUTHENTICATIONLEVEL",  "Unable to set required authentication level for update request"
  Data.l $80110414: Data$ "COMADMIN_E_USERPASSWDNOTVALID",  "The identity or password set on the application is not valid"
  Data.l $80110418: Data$ "COMADMIN_E_CLSIDORIIDMISMATCH",  "Application file CLSIDs or IIDs do not match corresponding DLLs"
  Data.l $80110419: Data$ "COMADMIN_E_REMOTEINTERFACE",  "Interface information is either missing or changed"
  Data.l $8011041A: Data$ "COMADMIN_E_DLLREGISTERSERVER",  "DllRegisterServer failed on component install"
  Data.l $8011041B: Data$ "COMADMIN_E_NOSERVERSHARE",  "No server file share available"
  Data.l $8011041D: Data$ "COMADMIN_E_DLLLOADFAILED",  "DLL could not be loaded"
  Data.l $8011041E: Data$ "COMADMIN_E_BADREGISTRYLIBID",  "The registered TypeLib ID is not valid"
  Data.l $8011041F: Data$ "COMADMIN_E_APPDIRNOTFOUND",  "Application install directory not found"
  Data.l $80110423: Data$ "COMADMIN_E_REGISTRARFAILED",  "Errors occurred while in the component registrar"
  Data.l $80110424: Data$ "COMADMIN_E_COMPFILE_DOESNOTEXIST",  "The file does not exist"
  Data.l $80110425: Data$ "COMADMIN_E_COMPFILE_LOADDLLFAIL",  "The DLL could not be loaded"
  Data.l $80110426: Data$ "COMADMIN_E_COMPFILE_GETCLASSOBJ",  "GetClassObject failed in the DLL"
  Data.l $80110427: Data$ "COMADMIN_E_COMPFILE_CLASSNOTAVAIL",  "The DLL does not support the components listed in the TypeLib"
  Data.l $80110428: Data$ "COMADMIN_E_COMPFILE_BADTLB",  "The TypeLib could not be loaded"
  Data.l $80110429: Data$ "COMADMIN_E_COMPFILE_NOTINSTALLABLE",  "The file does not contain components or component information"
  Data.l $8011042A: Data$ "COMADMIN_E_NOTCHANGEABLE",  "Changes to this object and its sub-objects have been disabled"
  Data.l $8011042B: Data$ "COMADMIN_E_NOTDELETEABLE",  "The delete function has been disabled for this object"
  Data.l $8011042C: Data$ "COMADMIN_E_SESSION",  "The server catalog version is not supported"
  Data.l $8011042D: Data$ "COMADMIN_E_COMP_MOVE_LOCKED",  "The component move was disallowed, because the source or destination application is either a system application or currently locked against changes"
  Data.l $8011042E: Data$ "COMADMIN_E_COMP_MOVE_BAD_DEST",  "The component move failed because the destination application no longer exists"
  Data.l $80110430: Data$ "COMADMIN_E_REGISTERTLB",  "The system was unable to register the TypeLib"
  Data.l $80110433: Data$ "COMADMIN_E_SYSTEMAPP",  "This operation can not be performed on the system application"
  Data.l $80110434: Data$ "COMADMIN_E_COMPFILE_NOREGISTRAR",  "The component registrar referenced in this file is not available"
  Data.l $80110435: Data$ "COMADMIN_E_COREQCOMPINSTALLED",  "A component in the same DLL is already installed"
  Data.l $80110436: Data$ "COMADMIN_E_SERVICENOTINSTALLED",  "The service is not installed"
  Data.l $80110437: Data$ "COMADMIN_E_PROPERTYSAVEFAILED",  "One or more property settings are either invalid or in conflict with each other"
  Data.l $80110438: Data$ "COMADMIN_E_OBJECTEXISTS",  "The object you are attempting to add or rename already exists"
  Data.l $80110439: Data$ "COMADMIN_E_COMPONENTEXISTS",  "The component already exists"
  Data.l $8011043B: Data$ "COMADMIN_E_REGFILE_CORRUPT",  "The registration file is corrupt"
  Data.l $8011043C: Data$ "COMADMIN_E_PROPERTY_OVERFLOW",  "The property value is too large"
  Data.l $8011043E: Data$ "COMADMIN_E_NOTINREGISTRY",  "Object was not found in registry"
  Data.l $8011043F: Data$ "COMADMIN_E_OBJECTNOTPOOLABLE",  "This object is not poolable"
  Data.l $80110446: Data$ "COMADMIN_E_APPLID_MATCHES_CLSID",  "A CLSID with the same GUID as the new application ID is already installed on this machine"
  Data.l $80110447: Data$ "COMADMIN_E_ROLE_DOES_NOT_EXIST",  "A role assigned to a component, interface, or method did not exist in the application"
  Data.l $80110448: Data$ "COMADMIN_E_START_APP_NEEDS_COMPONENTS",  "You must have components in an application in order to start the application"
  Data.l $80110449: Data$ "COMADMIN_E_REQUIRES_DIFFERENT_PLATFORM",  "This operation is not enabled on this platform"
  Data.l $8011044A: Data$ "COMADMIN_E_CAN_NOT_EXPORT_APP_PROXY",  "Application Proxy is not exportable"
  Data.l $8011044B: Data$ "COMADMIN_E_CAN_NOT_START_APP",  "Failed to start application because it is either a library application or an application proxy"
  Data.l $8011044C: Data$ "COMADMIN_E_CAN_NOT_EXPORT_SYS_APP",  "System application is not exportable"
  Data.l $8011044D: Data$ "COMADMIN_E_CANT_SUBSCRIBE_TO_COMPONENT",  "Can not subscribe to this component (the component may have been imported)"
  Data.l $8011044E: Data$ "COMADMIN_E_EVENTCLASS_CANT_BE_SUBSCRIBER",  "An event class cannot also be a subscriber component"
  Data.l $8011044F: Data$ "COMADMIN_E_LIB_APP_PROXY_INCOMPATIBLE",  "Library applications and application proxies are incompatible"
  Data.l $80110450: Data$ "COMADMIN_E_BASE_PARTITION_ONLY",  "This function is valid for the base partition only"
  Data.l $80110451: Data$ "COMADMIN_E_START_APP_DISABLED",  "You cannot start an application that has been disabled"
  Data.l $80110457: Data$ "COMADMIN_E_CAT_DUPLICATE_PARTITION_NAME",  "The specified partition name is already in use on this computer"
  Data.l $80110458: Data$ "COMADMIN_E_CAT_INVALID_PARTITION_NAME",  "The specified partition name is invalid. Check that the name contains at least one visible character"
  Data.l $80110459: Data$ "COMADMIN_E_CAT_PARTITION_IN_USE",  "The partition cannot be deleted because it is the default partition for one or more users"
  Data.l $8011045A: Data$ "COMADMIN_E_FILE_PARTITION_DUPLICATE_FILES",  "The partition cannot be exported, because one or more components in the partition have the same file name"
  Data.l $8011045B: Data$ "COMADMIN_E_CAT_IMPORTED_COMPONENTS_NOT_ALLOWED",  "Applications that contain one or more imported components cannot be installed into a non-base partition"
  Data.l $8011045C: Data$ "COMADMIN_E_AMBIGUOUS_APPLICATION_NAME",  "The application name is not unique and cannot be resolved to an application id"
  Data.l $8011045D: Data$ "COMADMIN_E_AMBIGUOUS_PARTITION_NAME",  "The partition name is not unique and cannot be resolved to a partition id"
  Data.l $80110472: Data$ "COMADMIN_E_REGDB_NOTINITIALIZED",  "The COM+ registry database has not been initialized"
  Data.l $80110473: Data$ "COMADMIN_E_REGDB_NOTOPEN",  "The COM+ registry database is not open"
  Data.l $80110474: Data$ "COMADMIN_E_REGDB_SYSTEMERR",  "The COM+ registry database detected a system error"
  Data.l $80110475: Data$ "COMADMIN_E_REGDB_ALREADYRUNNING",  "The COM+ registry database is already running"
  Data.l $80110480: Data$ "COMADMIN_E_MIG_VERSIONNOTSUPPORTED",  "This version of the COM+ registry database cannot be migrated"
  Data.l $80110481: Data$ "COMADMIN_E_MIG_SCHEMANOTFOUND",  "The schema version to be migrated could not be found in the COM+ registry database"
  Data.l $80110482: Data$ "COMADMIN_E_CAT_BITNESSMISMATCH",  "There was a type mismatch between binaries"
  Data.l $80110483: Data$ "COMADMIN_E_CAT_UNACCEPTABLEBITNESS",  "A binary of unknown or invalid type was provided"
  Data.l $80110484: Data$ "COMADMIN_E_CAT_WRONGAPPBITNESS",  "There was a type mismatch between a binary and an application"
  Data.l $80110485: Data$ "COMADMIN_E_CAT_PAUSE_RESUME_NOT_SUPPORTED",  "The application cannot be paused or resumed"
  Data.l $80110486: Data$ "COMADMIN_E_CAT_SERVERFAULT",  "The COM+ Catalog Server threw an exception during execution"
  Data.l $80110600: Data$ "COMQC_E_APPLICATION_NOT_QUEUED",  "Only COM+ Applications marked 'queued' can be invoked using the 'queue' moniker"
  Data.l $80110601: Data$ "COMQC_E_NO_QUEUEABLE_INTERFACES",  "At least one interface must be marked 'queued' in order to create a queued component instance with the 'queue' moniker"
  Data.l $80110602: Data$ "COMQC_E_QUEUING_SERVICE_NOT_AVAILABLE",  "MSMQ is required for the requested operation and is not installed"
  Data.l $80110603: Data$ "COMQC_E_NO_IPERSISTSTREAM",  "Unable to marshal an interface that does not support IPersistStream"
  Data.l $80110604: Data$ "COMQC_E_BAD_MESSAGE",  "The message is improperly formatted or was damaged in transit"
  Data.l $80110605: Data$ "COMQC_E_UNAUTHENTICATED",  "An unauthenticated message was received by an application that accepts only authenticated messages"
  Data.l $80110606: Data$ "COMQC_E_UNTRUSTED_ENQUEUER",  "The message was requeued or moved by a user not in the 'QC Trusted User' role"
  Data.l $80110701: Data$ "MSDTC_E_DUPLICATE_RESOURCE",  "Cannot create a duplicate resource of type Distributed Transaction Coordinator"
  Data.l $80110808: Data$ "COMADMIN_E_OBJECT_PARENT_MISSING",  "One of the objects being inserted or updated does not belong to a valid parent collection"
  Data.l $80110809: Data$ "COMADMIN_E_OBJECT_DOES_NOT_EXIST",  "One of the specified objects cannot be found"
  Data.l $8011080A: Data$ "COMADMIN_E_APP_NOT_RUNNING",  "The specified application is not currently running"
  Data.l $8011080B: Data$ "COMADMIN_E_INVALID_PARTITION",  "The partition(s) specified are not valid."
  Data.l $8011080D: Data$ "COMADMIN_E_SVCAPP_NOT_POOLABLE_OR_RECYCLABLE",  "COM+ applications that run as NT service may not be pooled or recycled"
  Data.l $8011080E: Data$ "COMADMIN_E_USER_IN_SET",  "One or more users are already assigned to a local partition set."
  Data.l $8011080F: Data$ "COMADMIN_E_CANTRECYCLELIBRARYAPPS",  "Library applications may not be recycled."
  Data.l $80110811: Data$ "COMADMIN_E_CANTRECYCLESERVICEAPPS",  "Applications running as NT services may not be recycled."
  Data.l $80110812: Data$ "COMADMIN_E_PROCESSALREADYRECYCLED",  "The process has already been recycled."
  Data.l $80110813: Data$ "COMADMIN_E_PAUSEDPROCESSMAYNOTBERECYCLED",  "A paused process may not be recycled."
  Data.l $80110814: Data$ "COMADMIN_E_CANTMAKEINPROCSERVICE",  "Library applications may not be NT services."
  Data.l $80110815: Data$ "COMADMIN_E_PROGIDINUSEBYCLSID",  "The ProgID provided to the copy operation is invalid. The ProgID is in use by another registered CLSID."
  Data.l $80110816: Data$ "COMADMIN_E_DEFAULT_PARTITION_NOT_IN_SET",  "The partition specified as default is not a member of the partition set."
  Data.l $80110817: Data$ "COMADMIN_E_RECYCLEDPROCESSMAYNOTBEPAUSED",  "A recycled process may not be paused."
  Data.l $80110818: Data$ "COMADMIN_E_PARTITION_ACCESSDENIED",  "Access to the specified partition is denied."
  Data.l $80110819: Data$ "COMADMIN_E_PARTITION_MSI_ONLY",  "Only Application Files (*.MSI files) can be installed into partitions."
  Data.l $8011081A: Data$ "COMADMIN_E_LEGACYCOMPS_NOT_ALLOWED_IN_1_0_FORMAT",  "Applications containing one or more legacy components may not be exported to 1.0 format."
  Data.l $8011081B: Data$ "COMADMIN_E_LEGACYCOMPS_NOT_ALLOWED_IN_NONBASE_PARTITIONS",  "Legacy components may not exist in non-base partitions."
  Data.l $8011081C: Data$ "COMADMIN_E_COMP_MOVE_SOURCE",  "A component cannot be moved (or copied) from the System Application, an application proxy or a non-changeable application"
  Data.l $8011081D: Data$ "COMADMIN_E_COMP_MOVE_DEST",  "A component cannot be moved (or copied) to the System Application, an application proxy or a non-changeable application"
  Data.l $8011081E: Data$ "COMADMIN_E_COMP_MOVE_PRIVATE",  "A private component cannot be moved (or copied) to a library application or to the base partition"
  Data.l $8011081F: Data$ "COMADMIN_E_BASEPARTITION_REQUIRED_IN_SET",  "The Base Application Partition exists in all partition sets and cannot be removed."
  Data.l $80110820: Data$ "COMADMIN_E_CANNOT_ALIAS_EVENTCLASS",  "Alas, Event Class components cannot be aliased."
  Data.l $80110821: Data$ "COMADMIN_E_PRIVATE_ACCESSDENIED",  "Access is denied because the component is private."
  Data.l $80110822: Data$ "COMADMIN_E_SAFERINVALID",  "The specified SAFER level is invalid."
  Data.l $80110823: Data$ "COMADMIN_E_REGISTRY_ACCESSDENIED",  "The specified user cannot write to the system registry"
  Data.l $80110824: Data$ "COMADMIN_E_PARTITIONS_DISABLED",  "COM+ partitions are currently disabled."
EndDataSection

#__COM_ErrorCodeCount = 1081

