;
; PureBasic COM Object Framework
;   by Timo 'fr34k' Harter (purebasic@freak1.de)
;
; See the 'Readme.txt' for help and licence information.
;

Structure __COM_ITTAPI_Vtbl Extends __COM_IUnknown_Vtbl
  GetTypeInfoCount.l
  GetTypeInfo.l
  GetIDsOfNames.l
  Invoke.l
  Initialize.l
  Shutdown.l
  get_Addresses.l
  EnumerateAddresses.l
  RegisterCallNotifications.l
  UnregisterNotifications.l
  get_CallHubs.l
  EnumerateCallHubs.l
  SetCallHubTracking.l
  EnumeratePrivateTAPIObjects.l
  get_PrivateTAPIObjects.l
  RegisterRequestRecipient.l
  SetAssistedTelephonyPriority.l
  SetApplicationPriority.l
  put_EventFilter.l
  get_EventFilter.l
EndStructure

Macro BuildCOMVTable_ITTAPI(__Object__)
  __COM_VTABLE_SetIUnknown(__Object__, ITTAPI)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, GetTypeInfoCount, 1)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, GetTypeInfo, 3)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, GetIDsOfNames, 5)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, Invoke, 8)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, Initialize, 0)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, Shutdown, 0)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, get_Addresses, 1)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, EnumerateAddresses, 1)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, RegisterCallNotifications, 6)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, UnregisterNotifications, 1)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, get_CallHubs, 1)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, EnumerateCallHubs, 1)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, SetCallHubTracking, 2)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, EnumeratePrivateTAPIObjects, 1)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, get_PrivateTAPIObjects, 1)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, RegisterRequestRecipient, 3)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, SetAssistedTelephonyPriority, 2)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, SetApplicationPriority, 3)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, put_EventFilter, 1)
  __COM_VTABLE_SetMethod(__Object__, ITTAPI, get_EventFilter, 1)
  __COM_VTABLE_SetDebug(__Object__, ITTAPI)
EndMacro

DefineGUID(IID_ITTAPI, $B1EFC382, $9355, $11D0, $83, $5C, $00, $AA, $00, $3C, $CA, $BD)
